(function(){
    "use strict";

    angular.module("noc").service("nocUploader", function () {
        return function(nocHttp){
            var scope = this;

            scope.upload = function(description, fileDescriptors, uploadUrl) {
                var fd = new FormData();
                var headers = {"Content-Type": undefined};
                _.forEach(fileDescriptors, function(descriptor) {
                    fd.append(descriptor.fieldName, descriptor.file.name);
                    fd.append(descriptor.uploadFormField,  descriptor.file);
                    headers[descriptor.fieldName] = descriptor.file.name;
                });

                return nocHttp.post({
                    url: uploadUrl,
                    data: fd,
                    headers: headers,
                    transformRequest: angular.identity
                }, description, nocHttp.BLOCK);
            };
        };
    });
}());