(function () {
    "use strict";
    angular.module('noc').directive('nocCheckbox', function () {
        var labelElement;
        return{
            restrict: 'A',
            require: 'ngModel',
            scope: false,
            link: function (scope, element, attr, ngModel) {
                labelElement = $('<label class="checkbox-label">');
                element.wrap(labelElement);
                element.parent().append(attr['text']);

                scope.$watch(function () {
                        return ngModel.$modelValue;
                    },
                    function () {
                        if (ngModel.$modelValue) {
                            element.parent().addClass('checkbox-label-checked');
                        } else {
                            element.parent().removeClass('checkbox-label-checked');
                        }
                    });
                attr.$observe('disabled',function (value) {
                    if (value) {
                        element.parent().addClass('checkbox-label-disabled');
                    } else {
                        element.parent().removeClass('checkbox-label-disabled');}
                });

                element.focus(function() {
                    element.parent().addClass('checkbox-label-focused');
                });
                element.blur(function() {
                    element.parent().removeClass('checkbox-label-focused');
                });
            }
        };
    });
})();
