angular.module('noc').component('costBreakdownCategoryComponent', {
    bindings: {
        totalMonthCost: '<',
        icon: '@',
        subtitle: '@',
        data: '<',
        isTooltipNeeded: '<'
    },
    templateUrl: 'assets/templates/components/cost/cost-breakdown-category-component.html',
    controllerAs: 'ctrlCostBreakdownCategory',
    controller: function ($filter, providerDiskTypes) {
        this.$onChanges = () => {
            if (this.data === undefined) {
                this.totalCategoryCost = 0;
            } else {
                _.forEach(this.data.costByUsage, (type) => {
                    type.cost._amount = $filter('number')(type.cost.amount, 2);
                    if (this.data.name === 'EBS' && providerDiskTypes.AWS[type.name]) {
                        type._name = providerDiskTypes.AWS[type.name].display;
                    } else {
                        type._name = type.name;
                    }
                });
                this.totalCategoryCost = this.data.total.amount;
            }
            this.totalCategoryCostRounded = _.round(this.totalCategoryCost, 2);
            this.totalCategoryCostFormatted = $filter('number')(this.totalCategoryCost, 2);
            if (this.totalCategoryCost && this.totalMonthCost) {
                this.percentage = _.round(this.totalCategoryCost / this.totalMonthCost * 100, 1);
            } else this.percentage = 0;
        };
    }
});
