angular.module('noc').component('costSavingBreakdownComponent', {
    bindings: {
        savingsData: '<',
        totalSaving: '<'
    },
    templateUrl: 'assets/templates/components/cost/cost-saving-breakdown-component.html',
    controller: function () {
        this.$onInit = () => {
            this.savingsMap = this.constructDataArray(this.savingsData.savings);
            this.calcData(this.savingsMap, this.totalSaving);
        };

        this.constructDataArray = (savingsData) => {
            if (savingsData) {
                // eslint-disable-next-line no-undef
                return new Map(_.map(savingsData, (val) => [val.name, val.monthlySaving.amount]));
            }
        };

        this.calcData = (dataMap, totalSaving) => {
            this.thinProvAmount = Math.round(dataMap.get('Thin Provisioning') * 10) / 10;
            this.compressionAmount = Math.round(dataMap.get('Compression') * 10) / 10;
            this.deduplicationAmount = Math.round(dataMap.get('Deduplication') * 10) / 10;
            this.tieringAmount = Math.round(dataMap.get('Tiering') * 10) / 10;

            this.thinProvAmountPercent = this.getPercentage(this.thinProvAmount, totalSaving);
            this.compressionAmountPercent = this.getPercentage(this.compressionAmount, totalSaving);
            this.deduplicationAmountPercent = this.getPercentage(this.deduplicationAmount, totalSaving);
            this.tieringAmountPercent = this.getPercentage(this.tieringAmount, totalSaving);
        };

        this.getPercentage = (amount, total) => {
            return Math.round((amount / total) * 1000) / 10;
        };
    }
});