(() => {
    'use strict';

    //This config is a workaround for bug in ui-grid, that prevents mousewheel scrolling on ui-grids.
    //
    //ui-grid issue: https://github.com/angular-ui/ui-grid/issues/1926
    //This config is based on a workaround suggested there: https://github.com/angular-ui/ui-grid/issues/1926#issuecomment-226547114
    //After the issue will be fixed and ui-grid version will be updated to contain the fix then this file can be deleted.
    //NOTICE: in the time of writing the issue is marked as 'closed' but in reality it's still happening.
    angular.module('noc').config(($provide) => {
        $provide.decorator('Grid', ($delegate, $timeout) => {
            $delegate.prototype.renderingComplete = function renderingComplete() {
                if (angular.isFunction(this.options.onRegisterApi)) {
                    this.options.onRegisterApi(this.api);
                }
                this.api.core.raise.renderingComplete(this.api);
                $timeout(() => {
                    const $viewport = $('.ui-grid-render-container');
                    $viewport.unbind('wheel'); //More events can be unbinded the same way, if needed: 'DomMouseScroll', 'MozMousePixelScroll', 'keydown', 'mousewheel', 'touchstart', 'touchmove', 'touchend'
                });
            };

            return $delegate;
        });
    });
})();
