angular.module("noc.components").directive('nocUiGridAutoHeight', function ($log) {
    "use strict";
    return {
        restrict:'A',
        require: 'uiGrid',
        compile: function() {
            return {
                pre: function (scope, element, attrs, ctrl) {
                    ctrl.grid.api.core.on.renderingComplete(scope, function () {
                        ctrl.grid.registerDataChangeCallback(function(grid) {
                            var gridRowHeight = (grid.options.rowHeight + 0), gridHeight = grid.options.data.length * gridRowHeight + 60;
                            $log.debug("Grid height with "+ grid.options.data.length + " items is set to " + gridHeight);
                            element.height(gridHeight);
                        });
                    });
                }
            };
        }
    };
});
