//makes the pinned columns shadow the unpinned ones
angular.module("noc.components").directive('gridShadow', function ($timeout) {
    "use strict";

    // returns a function that warps the element and puts it in position
    var calculateFunction = function(element) {
        var calculation = function() {
            var pinnedHeader = $('.ui-grid-pinned-container .ui-grid-header-cell-wrapper'),
                pinnedHeaderOffset = pinnedHeader.offset();

            if (!pinnedHeaderOffset) return;
            var leftOffset = pinnedHeaderOffset.left + pinnedHeader.width(),
                topOffset = pinnedHeaderOffset.top;

            element.css('left', leftOffset);
            element.css('top', topOffset);

            var canvasHeight = $('.ui-grid-canvas').height();
            var headerHeight = pinnedHeader.height();
            // Canvas height has a little extra height for horizontal scroll bar
            element.css('height', canvasHeight + headerHeight - 14);
        };

        return function() {
            $timeout(calculation);
        };
    };

    return {
        restrict:'E',
        template:'<div class="grid-shadow" ng-class="{show: gridIsScrolled}"></div>',
        scope: true,
        replace: true,
        link: function($scope, element){
            var unwatch = $scope.$watch('gridAPI', function(gridAPI) {
                if (gridAPI) {
                    unwatch();
                    var calculate = calculateFunction(element);

                    gridAPI.colResizable.on.columnSizeChanged($scope, calculate);
                    gridAPI.core.on.rowsRendered($scope, calculate);
                    gridAPI.grid.registerDataChangeCallback(calculate);
                    $scope.$watch("alertMessages", calculate);
                    $scope.$on("header-change-height", calculate);
                }
            });
        }
    };
});