// Grid menu killer is responsible for closing the open menu when there is a click anywhere but on the menu
angular.module("noc.components").directive('volViewGridMenuKiller', function ($document) {
    "use strict";
    return {
        controller: function() {
            var lastOpenedMenu = null;

            this.setLastOpenedMenu = function(el, ctrl) {
                if (lastOpenedMenu) lastOpenedMenu.ctrl.close();
                lastOpenedMenu = {element: el, ctrl: ctrl};
            };

            this.getLastOpenedMenu = function() {
                return lastOpenedMenu;
            };
        },
        restrict:'A',
        require: "volViewGridMenuKiller",
        link: function(scope, element, attrs, ctrl){
            var body = $document.find('body');
            var clickKiller = function (event) {
                var lastOpenedMenu = ctrl.getLastOpenedMenu();
                if (!lastOpenedMenu) return;
                //Close menu if clicked outside it's area:
                if ($(event.target).closest('.vol-view-volume-menu')[0] !== $(lastOpenedMenu.element)[0]) {
                    lastOpenedMenu.ctrl.close();
                }
            };

            body.on("click", clickKiller);

            scope.$on('$destroy', () => {
                body.off('click', clickKiller);
            });
        }
    };
});

angular.module("noc.components").directive('volViewGridMenu', function () {
    "use strict";

    return {
        controller: function($scope) {
            $scope.opened = false;

            this.close = function() {
                $scope.opened = false;
            };
        },
        restrict:'E',
        templateUrl: 'assets/templates/components/grid/vol-view-grid-menu.html',
        replace: true,
        require: ["volViewGridMenu", "^volViewGridMenuKiller"],
        link: function($scope, element, attrs, ctrls){
            var menuCtrl = ctrls[0], killerCtrl = ctrls[1];
            $scope.gridName = attrs.gridName;

            $scope.toggleOpen = function() {
                // register as the last opened menu upon opening
                if (!$scope.opened) {
                    killerCtrl.setLastOpenedMenu(element, menuCtrl);
                }
                $scope.opened = !$scope.opened;
            };
        }
    };
});
