angular.module("noc.components").directive('nocIcon', function (nocIconMap, $http, $templateCache) {
    "use strict";

    var svgs = {},
        sizes = {
            'xx-small': 'xx-small-svg',
            'x-small': 'x-small-svg',
            small: 'small-svg',
            medium: 'medium-svg',
            large: 'large-svg',
            'x-large': 'x-large-svg'
        };

    var getIconSize = function (attrs) {
        var size = attrs.nocSize;
        return sizes[size];
    };

    var loadReplaceSvg = function loadReplaceSvg(el, attrs, replace){
        import(`images/icons/${attrs.name}.svg`).then((module) => {
            const svgUrl = module.default;

          if (replace) {
            el.children()[0].remove();
          }
          el.append(svgUrl);

          el.addClass([attrs.name + "-icon", getIconSize(attrs)].join(' '));
        });



        // $http.get(svgUrl, {cache: $templateCache})
        //     .then(function (svgResponse) {
        //         if(replace){
        //             el.children()[0].remove();
        //         }
        //         el.append(svgResponse.data);
        //     }).catch(function () {
        //         throw new Error('Cloud not find svg ' + svgUrl);
        //     });
        // el.addClass([attrs.name + "-icon", getIconSize(attrs)].join(' '));
    };

    return {
        restrict: 'E',
        scope: true,
        link: function (scope, el, attrs) {

            var hasIcon;

            attrs.$observe('name', function () {
                if (!hasIcon) {
                    loadReplaceSvg(el, attrs, false);
                    hasIcon = true;
                } else {
                    loadReplaceSvg(el, attrs, true);
                }
            });
        }
    };
});

