(function(){
    "use strict";

    function directiveFunc(name){
        return /*@ngInject*/function (keypressHelper,$interpolate) {
            var paramTemplate = $interpolate('{ {{key}}: \'{{clickExpression}}\'}');
            var eventName = _.toLower(name.substr(3));

            return {
                link: function (scope, elm, attrs) {
                    var param = attrs[name];

                    if (/^\{.+\}$/g.test(_.trim(param))) {
                        //param is an object as ui-utils expects - do nothing
                    }else{
                        if (attrs.ngClick) {
                            //assume that param is a valid ui-utils parameters key
                            //use the element ng-click as the expression
                            param = paramTemplate({key: param, clickExpression: _.replace(attrs.ngClick, /'/g, "\\'")});
                        }
                    }

                    var uiUtilsDirectiveName = _.replace(name, /^noc/, 'ui');
                    attrs[uiUtilsDirectiveName] = param;

                    keypressHelper(eventName, scope, elm, attrs);
                }
            };
        };
    }

    angular.module("noc.components").directive('nocKeypress', directiveFunc('nocKeypress'));
    angular.module("noc.components").directive('nocKeydown', directiveFunc('nocKeydown'));
    angular.module("noc.components").directive('nocKeyup', directiveFunc('nocKeyup'));
})();