(function(){
    "use strict";
    angular.module('noc.components').directive('nocAutoHeightAnimation', function($log, $timeout){

        return{
            restrict: 'A',
            link: function (scope, element) {

                var handler = function () {
                    $log.debug("DOM Manipulation detected");
                    $timeout(function () {
                        var childrenHeight = 0;
                        jElement.children().each(function () {
                            childrenHeight += $(this).outerHeight(true);
                        });
                        jElement.height(childrenHeight);
                    });
                };

                var jElement = $(element);
                jElement.bind("DOMSubtreeModified", handler);

                scope.$on('$destroy', function() {
                    jElement.unbind("DOMSubtreeModified", handler);
                });
            }
        };
    });
})();
