// use on relative positioned elements, makes them fixed in their Y axis. (but not the X)
angular.module("noc.components").directive('nocFixedY', function ($document) {
    return {
        restrict:'A',
        link: function (scope, element, attrs) {
            var scrollThreshold = parseInt(attrs['nocFixedY']) || 0;
            var onScroll = function () {
                var scrollOffset = $document.scrollTop();

                if (scrollOffset >= scrollThreshold) {
                    element.css("top", scrollOffset - scrollThreshold);
                } else {
                    element.css("top", 0);
                }
            };

            var document = $($document);

            document.on("scroll", onScroll);

            scope.$on('$destroy', function () {
                document.off("scroll", onScroll);
            });
        }
    };
});