(() => {
    'use strict';

    /*
     * This directive is a workaround for bug in ui-select component.
     * After that bug is closed there and we update the ui-select version to a version that includes the fix we can
     * probably delete this directive.
     * See: https://github.com/angular-ui/ui-select/issues/832
     * The code is based on the directive mentioned in one of the comments there, but I had to do some changes to make
     * it work.
     * Original example is here: http://jsfiddle.net/eXQf3/753/
     */
    /* istanbul ignore next */
    angular.module('noc.components').directive('uiSelectChoices', () => {
        return {
            restrict: 'E',
            link: (scope, element) => {
                element.bind('wheel', (event) => {
                    const context = element.context;
                    const heightDif = context.offsetHeight - context.clientHeight;
                    const maxScrollTop = context.scrollHeight - context.offsetHeight + heightDif;

                    if ((context.scrollTop === maxScrollTop && event.originalEvent.deltaY > 0) ||
                        (context.scrollTop === 0 && event.originalEvent.deltaY < 0)) {
                        event.preventDefault();
                    }
                });
            }
        };
    });
})();
