(() => {
    'use strict';
    angular.module('noc.components').directive('nocUnique', (ValidationKeys) => {
        return {
            require: ['ngModel', '^ngForm'],
            restrict: 'A',
            link: function link(scope, element, attributes, ctrl) {
                const ngModelCtrl = ctrl[0];
                const nocNgFormCtrl = ctrl[1];

                const descriptor = {
                    modelCtrl: ngModelCtrl,
                    oldValue: ngModelCtrl.$viewValue || ngModelCtrl.$modelValue
                };

                nocNgFormCtrl.addInput(descriptor, ValidationKeys.NOC_UNIQUE_VALIDATION_KEY);

                const validator = (viewValue) => {
                    nocNgFormCtrl.validate(descriptor, viewValue, ValidationKeys.NOC_UNIQUE_VALIDATION_KEY);

                    return viewValue;
                };

                ngModelCtrl.$parsers.push(validator);
                ngModelCtrl.$formatters.push(validator);

                scope.$on('$destroy', () => {
                    nocNgFormCtrl.removeInput(descriptor, ValidationKeys.NOC_UNIQUE_VALIDATION_KEY);
                });
            }
        };
    });
})();
