(() => {
    'use strict';

    angular.module('noc').constant('virginWizardTreeBuilder', ($stateProvider, tree, steps, baseState) => {
        baseState = baseState || "";
        var buildStates = function(node, name, parentPath) {

            var step = _.cloneDeep(_.find(steps, {name: name}));
            var newPath = parentPath ? parentPath + '.' + name : name;
            step.url = step.url || "/" + name;
            step.data = step.data || {};
            step.data.name = name;
            if (step.wizardTemplateUrl) {
                step.template = '<noc-super-duper></noc-super-duper>' +
                    '<ng-include ng-if="appView === \'storage-system-view\' && currentStateName === \'' + name + '\'" src="\'assets/templates/components/virgin-wizard/previous.html\'"></ng-include>' +
                    '<form novalidate><input type="text" style="display:none"><input type="password" style="display:none"><ng-include src="\'' + step.wizardTemplateUrl + '\'"></ng-include></form>' +
                    '<div><div ui-view></div></div>';
                delete step.templateUrl;
                delete step.wizardTemplateUrl;
            }
            delete step.name;
            $stateProvider.state(newPath, step);

            if (node === true) return;
            _.forEach(node, function(value, key) {
                buildStates(value, key, newPath);
            });
        };

        var rootName = _.keys(tree)[0];

        var stepsNames = _.map(steps, 'name');
        if (stepsNames.length !== _.uniq(stepsNames).length) throw new Error(rootName + " configuration contains duplicate step names");

        buildStates(tree[rootName], rootName, baseState);
    });
})();
