(function(){
    "use strict";
    angular.module('noc.components').directive('nocUnavailableInstancesAlert', function () {
        return {
            restrict: 'E',
            scope: true,
            controller: "StoppedInstancesAlertController",
            link: function(scope, ele, attrs){
                scope.volumeType = attrs.volumeType;
            },
            template: "<div ng-show='hasUnavailableInstances'>One or more AWS instances are unavailable. Cloud Manager can create volumes on existing instances but they must be in the 'on' or 'initializing' state.</div>"
        };
    });

    angular.module('noc.components').controller('StoppedInstancesAlertController', function ($scope, nocHttp, volViewVolumesResource) {
        volViewVolumesResource.hasUnavailableInstances(nocHttp, $scope.volumeType).then(function (hasUnavailableInstances) {
            $scope.hasUnavailableInstances = !!hasUnavailableInstances;
        });
    });
})();