((angular) => {
    'use strict';

    angular.module('noc.components').directive('vvSearchWidget', searchWidget);

    function searchWidget() {
        return {
            restrict: 'E',
            templateUrl: 'assets/templates/components/volume-view-search-widget.html',
            link: linkFunction,
            require: 'ngModel',
            scope: {
                searchString: "=ngModel",
                ngChange: "=ngChange"
            }
        };

        function linkFunction(scope, el, attrs, modelCtrl) {
            var input = el.find("input");
            input.on("focus", function () {
                el.addClass("search-focus");
                scope.enableSearchFields = true;
            });

            var isCloseable = 'closeable' in attrs;
            scope.enableSearchFields = !isCloseable;

            const onBlur = () => {
                if (!modelCtrl.$viewValue) {
                    scope.enableSearchFields = false;
                }
            };

            function clearSearchString(){
                scope.searchString = '';
                if(_.isFunction(scope.ngChange)) scope.ngChange();
            }

            function disappearOnBlur(){
                if (scope.searchString === '') {
                    el.removeClass("search-focus");
                }
            }

            scope.clear = function () {
                clearSearchString();
                el.removeClass("search-focus");
                scope.enableSearchFields = false;
            };

            attrs.$observe('placeholder', function (value) {
                input.prop('placeholder', value);
            });

            if (isCloseable) {
                input.bind('blur', onBlur);
            }

            input.on("blur", function () {
                disappearOnBlur();
            });
        }
    }
})(angular);
