(function () {
    angular.module('noc.components').controller('VVAddTagsController', function ($scope, nocHttp, volViewGeneralResource, Patterns) {
        // Can't inject nocHttp with isolated scope, so we are using the parent scope directly.
        var tagsCtrl = this;
        if (_.isUndefined($scope.customTags)) throw new Error('customTags should be defined on the parent scope.');
        volViewGeneralResource.getAWSTags(nocHttp)
            .then(function(AwsTags){
                $scope.tagsExist = false;
                //showFirstTag opens first input field if no tags exist yet (only occurs in AWS Tags in menu)
                if (AwsTags.length === 0 && tagsCtrl.showFirstTag) {
                    $scope.customTags = [{tagKey: "", tagValue: ""}];
                } else {
                    $scope.customTags = AwsTags;
                }
                $scope.originalTags = angular.copy($scope.customTags);
                $scope.showButton = true;
                if ($scope.originalTags.length !== 0) {
                    $scope.tagsExist = true;
                }
            });

        $scope.addCustomAwsTag = function(){
            $scope.customTags.push({tagKey: "", tagValue: ""});
        };

        $scope.removeCustomAwsTag = function(tag){
            $scope.customTags = _.without($scope.customTags, tag);
            _formCtrl.$setDirty();
        };

        var regexTagKey = 'amazonTagKey';
        $scope.weTagKeyRegex = new RegExp(Patterns[regexTagKey].regex);
        $scope.workingEnvironmentTagKeyError = regexTagKey;
        var regexTagValue = 'amazonTagValue';
        $scope.weTagValueRegex = new RegExp(Patterns[regexTagValue].regex);
        $scope.workingEnvironmentTagValueError = regexTagValue;

        var _formCtrl;
        tagsCtrl.showFirstTag = false;
        tagsCtrl.setFormController = function(formCtrl) {
            _formCtrl = formCtrl;
        };

    });

    angular.module('noc.components').directive('volumeViewAddTags', function () {
        "use strict";
        return {
            restrict: 'E',
            require: ['^form', 'volumeViewAddTags'],
            templateUrl: 'assets/templates/components/volume-view-add-tags.html',
            controller: 'VVAddTagsController',
            replace: true,
            scope: false,
            link: function ($scope, element, attrs, ctrls) {
                var formCtrl = ctrls[0], addTagsCtrl = ctrls[1];
                $scope.providerName = attrs['providerName'];
                addTagsCtrl.showFirstTag = $scope.$eval(attrs['showFirstTag']);
                addTagsCtrl.setFormController(formCtrl);
            }
        };

    });

})();

