angular.module("noc.components").directive('nocContinue', function () {
    "use strict";

    return {
        restrict: 'E',
        templateUrl: 'assets/templates/wizards/common/continue-button.html',
        replace: true,
        require: "^form",
        scope: {
            click: "&"
        },
        link: function(scope, element, attrs, ngFormCtrl) {
            var button = element.find('button'), isGoBtn = element.hasClass('go');
            var CLASS_NAME = 'ok2go';

            button.addClass(isGoBtn ? 'go-btn' : 'continue-btn');

            // removes the label in case of go
            var label = button.next();
            if (isGoBtn) {
                label.remove();
            }

            scope.$watch(function () {
                return ngFormCtrl.$valid;
            }, function (validity) {
                if (validity) {
                    button.addClass(CLASS_NAME);
                } else {
                    button.removeClass(CLASS_NAME);
                }
            });
        }
    };
});
