(() => {
    'use strict';

    angular.module('noc').value('nocBaseUrl', '/occm/api');

    const constants = {};
    angular.module('noc').value('Constants', constants);
    constants.maxInt32 = 2147483647; //2^31 - 1
    constants.system = {};
    constants.system.retriesEnabled = false;

    constants.broadcastEventNames = {
        MODAL_OK_CLICKED: 'MODAL_OK_CLICKED'
    };

    constants.HEADER_HEIGHT_CHANGED_EVENT = 'nocMatchHeaderHeight:HEADER_HEIGHT_CHANGE';

    constants.ASYNC_OPERATION_ERROR_EVENT = 'asyncOperationError409';

    constants.typeToLongNameMap = {
        'VSA': 'Cloud Volumes ONTAP',
        'NPS': 'NPS',
        'ON_PREM': 'On-Premises',
        'HA': 'Cloud Volumes ONTAP HA'
    };


    constants.dataONTAPLocations = {
        'ON_PREM': {
            value: 'ON_PREM',
            displayName: 'On Premises',
            providerName: '',
            location: 'On Premises',
            description: '',
            shortName: 'On-Prem'
        },
        'AWS': {
            value: 'AWS',
            displayName: 'AWS',
            providerName: 'AWS',
            location: 'AWS',
            description: 'Web Services',
            shortName: 'AWS'
        },
        'AZURE': {
            value: 'AZURE',
            displayName: 'Azure',
            providerName: 'Azure',
            location: 'Azure',
            description: 'Microsoft',
            shortName: 'Azure'
        },
        'GCP': {
            value: 'GCP',
            displayName: 'GCP',
            providerName: 'GCP',
            location: 'GCP',
            description: 'Google Cloud',
            shortName: 'GCP'
        },
        'SOFTLAYER': {
            value: 'SOFTLAYER',
            displayName: 'IBM Cloud',
            providerName: 'IBM',
            location: 'IBM',
            description: 'Cloud',
            shortName: 'IBM'
        },
        'GOOGLE': {
            value: 'GOOGLE',
            displayName: 'Google',
            providerName: 'Google',
            location: 'Google',
            description: 'Cloud Platform',
            shortName: 'Google'
        }
    };

    constants.emptyReplicationScheduleDescription = 'One-time copy';

    constants.dialogWidthForDisplayingCertificate = 560; //IE needs the widest dialog in order to not break lines. See NOC-5850.

    constants.awsIopsLimitPerVolume = 20000;

    return constants;
})();
