(function () {
    "use strict";

    angular.module("noc").controller("UpdateNotificationDialogController", function ($scope, $rootScope, occmUpdateService, configService, nocHttp) {

        $scope.model = {};
        $scope.values = {};
        $scope.whatNewUrl = $rootScope.externalConfig.occm_release_notes_url;

        $scope.initialize = function () {
            configService.getConfig(nocHttp,['autoUpgrade'])
                .then(function(configResponse) {
                    $scope.values = configResponse;
                    $scope.originalValues = _.cloneDeep($scope.values);
                    $scope.loaded = true;
                });
        };

        $scope.dontShowAgain = function (update) {
            $scope.updateAutomaticUpgrade();
            occmUpdateService.dontShowAgain(update);
            $scope.modalCancel();
        };

        $scope.updateAutomaticUpgrade = function() {
            if($scope.model.enableAutomaticUpgrade) {
                $scope.values.autoUpgrade = $scope.model.enableAutomaticUpgrade;
                configService.updateConfig(nocHttp, ['autoUpgrade'], $scope.values, $scope.originalValues);
            }
        };

        $scope.initialize();
    });
}());