(() => {
    'use strict';

    angular.module('noc').controller('K8sClustersController', ($scope, KubernetesResource, nocHttp) => {

        $scope.initialize = () => {
            KubernetesResource.getK8sClusters(nocHttp)
                .then((clusters) => {
                    $scope.firstCluster = clusters.length === 0;
                });
        };

        $scope.goToFirstClusterScreen = () => {
            $scope.checkAndSetState('main.k8s-clusters.index');
        };

        $scope.goToDiscoverCluster = () => {
            $scope.checkAndSetState('main.k8s-clusters.discover-k8s-cluster');
        };

        $scope.goToK8sClustersSettings = () => {
            $scope.checkAndSetState('main.k8s-clusters.k8s-cluster-settings');
        };

        $scope.cancel = () => {
            if ($scope.firstCluster) {
                $scope.goToFirstClusterScreen();
            } else {
                $scope.goToK8sClustersSettings();
            }
        };

        $scope.initialize();
    });
})();
