(() => {
    'use strict';

    angular.module('noc').controller('KubernetesClusterSettingsController', ($scope, KubernetesResource, nocHttp,
                                                                             nocAuth0Service) => {
        $scope.initialize = () => {
            KubernetesResource.getK8sClusters(nocHttp)
                .then((response) => {
                    $scope.k8sClusters = _.sortBy(response, 'clusterName');
                    const audience = 'https://api.cloud.netapp.com';
                    nocAuth0Service.generateTokenForCustomAudience(audience)
                        .then((token) => {
                            KubernetesResource.getExternalClusters(nocHttp, token)
                                .then((externalClusters) => {
                                    $scope.k8sClusters = _.reject($scope.k8sClusters, 'nksInfo');
                                    if ($scope.k8sClusters.length > 0) {
                                        $scope.k8sClusters = _.sortBy($scope.k8sClusters.concat(externalClusters), 'connectivity', 'clusterName');
                                    } else if (externalClusters.length === 0) {
                                        $scope.checkAndSetState('main.k8s-clusters.index');
                                    } else {
                                        $scope.k8sClusters = _.sortBy(externalClusters, 'connectivity', 'clusterName');
                                    }
                                });
                        });
                });
        };

        $scope.initialize();
    });
})();
