(() => {
    'use strict';

    angular.module('noc').controller('LoginController', ($scope, nocUI, $rootScope, $log, nocUtil, Patterns, $timeout, AuthResource) => {
        $scope.logout = nocUI.logout;

        $scope.login = () => {
            const password = $('#loginPassword').val();

            // NOC-8941 login with Hebrew letters causes a wrong flow
            const emailValue = $('#loginEmail').val(),
                emailRegex = new RegExp(Patterns.stringNotEmpty255.regex),
                email = emailRegex.test(emailValue) ? emailValue : '';

            AuthResource.login(email, password)
                .then(() => {
                    nocUtil.logClientDetails();
                    //Will reload the application as well causing a call to /user
                    nocUI.reloadSilently();
                })
                .catch((response) => {
                    const error = response.data;
                    const status = response.status;

                    if (status === 401 || status === 400) {
                        //If not first failure, animate to catch user attention:
                        if ($scope.failed) {
                            $scope.animate = true;
                            $timeout(() => {
                                $scope.animate = false;
                            }, 1000);
                        }
                        $scope.errorStatus = status;
                        $scope.failed = true;
                    } else {
                        $log.error('Failed to login:' + error.message);
                        $rootScope.failureMessage = 'Unable to contact server.';
                        $rootScope.appState = 'failed';
                    }
                });
        };
    });
})();
