(() => {
    'use strict';

    angular.module('noc').service('AuditRecordTemplatesLatest', () => {
        const formatProbeType = function formatProbeType(info) {
            return '<span ng-if="' + info + '.probeType === \'Node1\'"><span>Node 1</span></span>' +
                '<span ng-if="' + info + '.probeType === \'Node2\'"><span>Node 2</span></span>' +
                '<span ng-if="' + info + '.probeType === \'Mediator\'"><span>Mediator</span></span>' +
                '<span ng-if="' + info + '.probeType === \'SingleNode\'"><span>Cloud Volumes ONTAP</span></span>';
        };

        /*eslint-disable key-spacing*/
        return {
            'Test Cloud Manager To Probe':  '<span>' +
                                   'Check connectivity from Cloud Manager ' +
                                   'to ' + formatProbeType('data._jsonParameters.probeInfo') +
                                   ' subnet {{data._jsonParameters.probeInfo.subnetCidr}}' +
                                   ' on {{data._jsonParameters.isMandatory ? "mandatory" : "optional" }} port {{data._jsonParameters.probeInfo.port}} ({{data._jsonParameters.portRole}})' +
                                   '</span>',
            'Test Probe To Probe': '<span>' +
                                   'Check connectivity from ' + formatProbeType('data._jsonParameters.sourceProbeInfo') +
                                   ' subnet {{data._jsonParameters.sourceProbeInfo.subnetCidr}}' +
                                   ' to ' + formatProbeType('data._jsonParameters.destinationProbeInfo') +
                                   ' subnet {{data._jsonParameters.destinationProbeInfo.subnetCidr}} ' +
                                   ' on {{data._jsonParameters.isMandatory ? "mandatory" : "optional" }} port {{data._jsonParameters.destinationProbeInfo.port}} ({{data._jsonParameters.portRole}})' +
                                   '</span>',
            'Test Probe To Occm':  '<span>' +
                                   'Check connectivity from ' + formatProbeType('data._jsonParameters.probeInfo') +
                                   ' subnet {{data._jsonParameters.probeInfo.subnetCidr}}' +
                                   ' to Cloud Manager on optional port {{data._jsonParameters.occmInfo.port}} (HTTP)' +
                                   '</span>',
            'Test Probe To Aws':   '<span>' +
                                   'Check connectivity from ' + formatProbeType('data._jsonParameters.probeInfo') +
                                   ' subnet {{data._jsonParameters.probeInfo.subnetCidr}}' +
                                   ' to AWS service in region {{data._jsonParameters.awsInfo.region}} (mandatory)' +
                                   '</span>',
            'Test Probe To S3':    '<span>' +
                                   'Check connectivity from ' + formatProbeType('data._jsonParameters.probeInfo') +
                                   ' subnet {{data._jsonParameters.probeInfo.subnetCidr}}' +
                                   ' to S3 service in region {{data._jsonParameters.awsInfo.region}} ' +
                                   '</span>'
        };
    });
})();
