(function () {
    "use strict";

    angular.module("noc").service("AuditTemplates-2.2.0", function (Constants) {
        var createReplicationTemplate =         "<span><span class='audit-text-action-name'>Create replication</span> from volume <span class='audit-text-value'>{{data._jsonParameters.replicationVolume.sourceVolumeName}}</span> to volume <span class='audit-text-value'>{{data._jsonParameters.replicationVolume.destinationVolumeName}}</span>";
        return {
            "Login" :                           "<span>User <span class='audit-text-value'>{{data.userName}}</span> <span class='audit-text-action-name'>logged in</span></span>",
            "Initial Setup" :                   "<span><span class='audit-text-action-name'>Initial setup</span></span>",
            "Volume View Initial Setup" :       "<span><span class='audit-text-action-name'>Volume view initial setup</span></span>",
            "Logout" :                          "<span>User <span class='audit-text-value'>{{data.userName}}</span> <span class='audit-text-action-name'>logged out</span></span>",
            "Backup Database" :                 "<span><span class='audit-text-action-name'>Backup</span> Cloud Manager database</span>",
            "Restore Database" :                "<span><span class='audit-text-action-name'>Restore</span> Cloud Manager database file: <span class='audit-text-value'>{{data._jsonParameters.filename}}</span></span>",
            "Set Simplicator Config" :          "<span><span class='audit-text-action-name'>Configuration update</span></span>",
            "Reset Simplicator Config" :        "<span><span class='audit-text-action-name'>Reset simplicator URL</span></span>",
            "Add Tenant" :                      "<span><span class='audit-text-action-name'>Create new tenant</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Update Tenant" :                   "<span><span class='audit-text-action-name'>Update tenant</span> information for <span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Delete Tenant" :                   "<span><span class='audit-text-action-name'>Delete tenant</span> <span class='audit-text-value'>{{data._jsonParameters.tenantName}}</span></span>",
            "Validate Tenant":                  "<span><span class='audit-text-action-name'>Validate tenant</span> <span class='audit-text-value'>{{data._jsonParameters.tenantName}}</span></span>",
            "Create User" :                     "<span><span class='audit-text-action-name'>Create user</span> <span class='audit-text-value'>{{data._jsonParameters.firstName}} {{data._jsonParameters.lastName}}</span> of role <span class='audit-text-value'>{{data._jsonParameters.roleName}}</span></span>",
            "Update User" :                     "<span><span class='audit-text-action-name'>Updated information for user</span> <span class='audit-text-value'>{{data._jsonParameters.userName}}</span> of role <span class='audit-text-value'>{{data._jsonParameters.roleName}}</span></span>",
            "Delete User" :                     "<span><span class='audit-text-action-name'>Delete user</span> <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span>",
            "Change Current User Keys" :        "<span><span class='audit-text-action-name'>Change AWS keys</span> for user <span class='audit-text-value'>{{data.userName}}</span></span>",
            "Change Current User Azure Credentials" : "<span><span class='audit-text-action-name'>Change Azure credentials</span> for user <span class='audit-text-value'>{{data.userName}}</span></span>",
            "Change Keys" :                     "<span><span class='audit-text-action-name'>Change AWS keys</span> for user <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span>",
            "Change Azure Credentials" :       "<span><span class='audit-text-action-name'>Change Azure credentials</span> for user <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span>",
            "Update Cost" :                     "<span><span class='audit-text-action-name'>Update cost</span> for user <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span>",
            "Reset Password" :                  "<span><span class='audit-text-action-name'>Reset Cloud Manager password</span> for user <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span>",
            "Grant Permission" :                "<span>" +
                                                "<span class='audit-text-action-name'>Permissions updated</span> for user " +
                                                "<span class='audit-text-value'>{{data._jsonParameters.userName}}:</span>" +
                                                "<span ng-if='data._jsonParameters.addWorkingEnvironmentNames.length'> granted to working environment(s) " +
                                                "<span class='audit-text-value'>{{data._jsonParameters.addWorkingEnvironmentNames}}</span>" +
                                                "</span>" +
                                                "<span ng-if='data._jsonParameters.addWorkingEnvironmentNames.length && data._jsonParameters.removeWorkingEnvironmentNames.length'> and</span>" +
                                                "<span ng-if='data._jsonParameters.removeWorkingEnvironmentNames.length'> revoked from working environment(s) " +
                                                "<span class='audit-text-value'>{{data._jsonParameters.removeWorkingEnvironmentNames}}</span>" +
                                                "</span>" +
                                                "</span>",
            "Change Current User Password" :    "<span><span class='audit-text-action-name'>Change Cloud Manager password</span></span>",
            "Create Vsa Working Environment" :  "<span><span class='audit-text-action-name'>Create new working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span> of type Cloud ONTAP</span>",
            "Delete Vsa Working Environment" :  "<span><span class='audit-text-action-name'><span ng-if=\"data._jsonParameters.localDelete == 'true'\">Remove</span><span ng-if=\"data._jsonParameters.localDelete != 'true'\">Delete</span> working environment</span> <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span><span ng-if='data._jsonParameters.localDelete'> from Cloud Manager</span></span>",
            "Delete Aws Ha Working Environment" :
                "<span><span class='audit-text-action-name'><span ng-if=\"data._jsonParameters.localDelete == 'true'\">Remove</span><span ng-if=\"data._jsonParameters.localDelete != 'true'\">Delete</span> highly available working environment</span> <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span><span ng-if='data._jsonParameters.localDelete'> from Cloud Manager</span></span>",
            "Delete Failed W E" :               "<span><span class='audit-text-action-name'>Delete failed working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Stop Vsa" :                        "<span><span class='audit-text-action-name'>Stop Cloud ONTAP for working environment</span> <span class='audit-text-value'>{{data.workingEnvironmentName}}</span></span>",
            "Stop Aws Ha":                      "<span><span class='audit-text-action-name'>Stop highly available Cloud ONTAP for working environment</span> <span class='audit-text-value'>{{data.workingEnvironmentName}}</span></span>",
            "Start Aws Ha":                     "<span><span class='audit-text-action-name'>Start highly available Cloud ONTAP for working environment</span> <span class='audit-text-value'>{{data.workingEnvironmentName}}</span></span>",
            "Suspend Cloud Ontap due to subscription expiry" :  "<span><span class='audit-text-action-name'>Suspend Cloud Ontap due to subscription expiry </span><span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Start Vsa" :                       "<span><span class='audit-text-action-name'>Start Cloud ONTAP for working environment</span> <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Update Vsa Configuration" :        "<span><span class='audit-text-action-name'>Update Cloud ONTAP backup configuration</span> <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Quote Volume":                     "<span>" +
                                                "<span class='audit-text-action-name'>Calculate required capacity</span> to accommodate volume <span class='audit-text-value'>{{data._jsonParameters.name}}</span>" +
                                                " of size <span class='audit-text-value'>{{data._jsonParameters.size.size}} {{data._jsonParameters.size.unit}}</span>" +
                                                "<span ng-if=\"data._jsonParameters.aggregateName\"> on aggregate <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>" +
                                                "</span>",
            "Create Volume" :                   "<span>" +
                                                "<span class='audit-text-action-name'>Create volume</span>" +
                                                " <span class='audit-text-value'>{{data._jsonParameters.name}}</span>" +
                                                " of size <span class='audit-text-value'>{{data._jsonParameters.size.size}} {{data._jsonParameters.size.unit}}</span>" +
                                                "<span ng-if=\"data._jsonParameters.aggregateName && !data._jsonParameters.createAggregateIfNotFound\"> on aggregate <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>" +
                                                "<span ng-if=\"data._jsonParameters.autoVsaCapacityManagementEnabled === false && data._jsonParameters.maxNumOfDisksApprovedToAdd !== undefined && data._jsonParameters.maxNumOfDisksApprovedToAdd >= 0\">" +
                                                " with approval to purchase <span class='audit-text-value'>{{data._jsonParameters.maxNumOfDisksApprovedToAdd}} disk{{data._jsonParameters.maxNumOfDisksApprovedToAdd != 1 ? 's' : '' }}</span>" +
                                                "</span>" +
                                                "</span>",
            "Create Managed Volume" :           "<span>" +
                                                "<span class='audit-text-action-name'>Create volume</span>" +
                                                " <span class='audit-text-value'>{{data._jsonParameters.name}}</span>" +
                                                " of size <span class='audit-text-value'>{{data._jsonParameters.size.size}} {{data._jsonParameters.size.unit}}</span>" +
                                                "</span>",
            "Delete Volume" :                   "<span><span class='audit-text-action-name'>Delete volume</span> <span class='audit-text-value'>{{data._jsonParameters.volumeName}}</span></span>",
            "Delete Managed Volume" :           "<span><span class='audit-text-action-name'>Delete volume</span> <span class='audit-text-value'>{{data._jsonParameters.managedVolumeId.split(':')[2]}}</span></span>",
            "Modify Volume" :                   "<span><span class='audit-text-action-name'>Modify volume</span> <span class='audit-text-value'>{{data._jsonParameters.volumeName}}</span></span>",
            "Modify Managed Volume" :           "<span><span class='audit-text-action-name'>Modify volume</span> <span class='audit-text-value'>{{data._jsonParameters.managedVolumeId.split(':')[2]}}</span></span>",
            "Clone Volume" :                    "<span><span class='audit-text-action-name'>Clone volume</span> <span class='audit-text-value'>{{data._jsonParameters.parentvolume || data._jsonParameters.volumeName}}</span> to <span class='audit-text-value'>{{data._jsonParameters.parentvolume ? data._jsonParameters.volumeName : data._jsonParameters.newVolumeName}}</span></span>",
            "Clone Managed Volume" :            "<span><span class='audit-text-action-name'>Clone volume</span> <span class='audit-text-value'>{{data._jsonParameters.parentvolume || data._jsonParameters.managedVolumeId.split(':')[2]}}</span> to <span class='audit-text-value'>{{data._jsonParameters.parentvolume ? data._jsonParameters.managedVolumeId.split(':')[2] : data._jsonParameters.newVolumeName}}</span></span>",
            "Assign Network Configuration To Tenant":
                                                "<span><span class='audit-text-action-name'>Assign network configuration</span></span>", //TODO needs to be updated once REST API is corrected
            "Set Password":                     "<span><span class='audit-text-action-name'>Setting cluster admin password for working environment </span><span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Add Storage Password":             "<span><span class='audit-text-action-name'>Add storage password </span></span>",
            "Update Password":                  "<span><span class='audit-text-action-name'>Update credentials for Data ONTAP working environment </span><span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Create Aggregate":                 "<span class='audit-text-action-name'>Create aggregate </span><span class='audit-text-value'>{{data._jsonParameters.name}}</span>",
            "Manually Activate Auto Vsa Capacity Management Cycle": "<span><span class='audit-text-action-name'>Manually activate VSA capacity automatic management cycle</span></span>",
            "Automatically Add Disks To Aggregate": "<span><span class='audit-text-action-name'>Automatically add disks to aggregate</span> <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>",
            "Automatically Delete Empty Aggregate": "<span><span class='audit-text-action-name'>Automatically delete aggregate</span> <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>",
            "Automatically Move Volume":        "<span><span class='audit-text-action-name'>Automatically move volume</span> from <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>",
            "Add Disks To Aggregate":           "<span><span class='audit-text-action-name'>Add disks to aggregate</span> <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>",
            "Delete Aggregate":                 "<span><span class='audit-text-action-name'>Delete aggregate</span> <span class='audit-text-value'>{{data._jsonParameters.aggregateName}}</span></span>",
            "Add Extension":                    "<span><span class='audit-text-action-name'>Add extension</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Delete Extension":                 "<span><span class='audit-text-action-name'>Delete extension</span></span>",
            "Update Extension":                 "<span><span class='audit-text-action-name'>Update extension</span></span>",
            "Execute Extension":                "<span><span class='audit-text-action-name'>Execute extension</span>",
            "Send Asup":                        "<span><span class='audit-text-action-name'>Send AutoSupport file</span>",
            "Save Asup Configuration":          "<span><span class='audit-text-action-name'>Save Send Support Information configuration</span>",
            "Download Asup File":               "<span><span class='audit-text-action-name'>Download AutoSupport file</span>",
            "Patch":                            "<span><span class='audit-text-action-name'>Manual Cloud Manager software update</span><span class='audit-text-value'> <span ng-show='data._jsonParameters.from.version'> from {{data._jsonParameters.from.version}} ({{data._jsonParameters.from.build | limitTo:7}})</span><span ng-show='data._jsonParameters.to.version'> to {{data._jsonParameters.to.version}} ({{data._jsonParameters.to.build | limitTo:7}})</span> using file {{data._jsonParameters.filename}}</span>",
            "Update Version":                   "<span><span class='audit-text-action-name'>Automatic Cloud Manager software update</span><span class='audit-text-value'> <span ng-show='data._jsonParameters.from.version'> from {{data._jsonParameters.from.version}} ({{data._jsonParameters.from.build | limitTo:7}})</span><span ng-show='data._jsonParameters.to.version'> to {{data._jsonParameters.to.version}} ({{data._jsonParameters.to.build | limitTo:7}})</span> using file {{data._jsonParameters.filename}}</span>",
            "Delete Failed Working Environment":"<span><span class='audit-text-action-name'>Delete failed working environment</span></span>",
            "Set Config Value":                 "<span>" +
                                                "<span ng-if=\"data._jsonParameters.key =='max_aggr_over_commitment_capacity_percentage' || data._jsonParameters.key =='max_aggr_free_space_percentage'\"><span>Capacity threshold <span class='audit-text-action-name'>{{data._jsonParameters.key | translateKey}}</span> changed to <span class='audit-text-value'>{{data._jsonParameters.value}}%</span></span></span>" +
                                                "<span ng-if=\"data._jsonParameters.key =='key_manager_port'\"><span><span class='audit-text-action-name'>Key Manager port</span> changed to <span class='audit-text-value'>{{data._jsonParameters.value}}</span></span></span>" +
                                                "</span>",
            "Update Config":                    "<span><span class='audit-text-action-name'>Update Cloud Manager configuration values</span></span>",
            "Recover":                          "<span><span class='audit-text-action-name'>Discover Cloud ONTAP working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name || data.workingEnvironmentName || data._jsonParameters.instanceName}}</span></span>",
            "Discover Azure":                   "<span><span class='audit-text-action-name'>Discover Cloud ONTAP working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name || data.workingEnvironmentName || data._jsonParameters.instanceName}}</span></span>",
            "Verify Cluster Credentials":       "<span><span class='audit-text-action-name'>Verify cluster credentials</span></span>",
            "Set Default Proxy":                "<span><span class='audit-text-action-name'>Set proxy to </span> <span class='audit-text-value'>{{data._jsonParameters.uri !== '' ? data._jsonParameters.uri : 'None'}}</span></span>",
            "Register Support":                 "<span><span class='audit-text-action-name'>Perform automatic support registration</span> for working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Set Tenant Nss Keys":              "<span><span class='audit-text-action-name'>Set NSS support keys</span><span> for tenant </span><span class='audit-text-value'>{{data._jsonParameters.tenantName}}</span></span>",
            "Register With Keys":               "<span><span class='audit-text-action-name'>Register to support with NSS keys</span><span>",
            "Discover On Prem":                 "<span><span class='audit-text-action-name'>Discover Data ONTAP working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Remove On Prem":                   "<span><span class='audit-text-action-name'>Remove Data ONTAP working environment</span> <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span></span>",
            "Retrieve On Prem":                 "<span><span class='audit-text-action-name'>Retrieve all Data ONTAP working environments</span> ",
            "Change S3 Bucket Name":            "<span><span class='audit-text-action-name'>Change S3 bucket name</span><span> for user</span> <span class='audit-text-value'>{{data._jsonParameters.userName}}</span></span> ",
            "Create Replication Vsa":           createReplicationTemplate,
            "Create Replication On Prem":       createReplicationTemplate,
            "Change Environment":               "<span><span class='audit-text-action-name'>Change environment to </span> <span class='audit-text-value'>{{data._jsonParameters.environment}}</span></span>",
            "Update Replication":               "<span>" +
                                                    "<span ng-if=\"data._jsonParameters.oldSchedule !== undefined\"><span class='audit-text-action-name'>Edit replication schedule</span> from <span class='audit-text-value'>{{data._jsonParameters.oldSchedule == '' ? '" + Constants.emptyReplicationScheduleDescription + "' : data._jsonParameters.oldSchedule}}</span><span> to </span><span class='audit-text-value'>{{data._jsonParameters.schedule}}</span></span>" +
                                                    "<span ng-if=\"data._jsonParameters.oldSchedule !== undefined && data._jsonParameters.oldMaxTransferRate !== undefined\"> and </span>" +
                                                    "<span ng-if=\"data._jsonParameters.oldMaxTransferRate !== undefined\"><span class='audit-text-action-name'>Edit replication Transfer Rate</span> from <span class='audit-text-value'>{{data._jsonParameters.oldMaxTransferRate == 0 ? 'Unlimited' : data._jsonParameters.oldMaxTransferRate + ' KB/s'}}</span><span> to </span><span class='audit-text-value'>{{data._jsonParameters.maxTransferRate == 0 ? 'Unlimited' : data._jsonParameters.maxTransferRate + ' KB/s'}}</span></span>" +
                                                    "<span> on volume</span> <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span>" +
                                                "</span>",
            "Resync Replication":               "<span><span class='audit-text-action-name'>Resync replication</span><span> on volume</span> <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span></span> ",
            "Uptodate Replication":             "<span><span class='audit-text-action-name'>Update replication</span><span> on volume</span> <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span></span> ",
            "Initialize Replication":           "<span><span class='audit-text-action-name'>Initialize replication</span><span> on volume</span> <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span></span> ",
            "Break Replication":                "<span><span class='audit-text-action-name'>Break replication</span><span> on volume</span> <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span></span> ",
            "Delete Replication":               "<span><span class='audit-text-action-name'>Delete replication</span> of destination volume <span class='audit-text-value'>{{data._jsonParameters.destinationVolumeName}}</span></span>",
            "Change License And Instance Type": "<span><span class='audit-text-action-name'>Change license and AWS instance type</span><span ng-show='data._jsonParameters.oldInstanceType'> from </span><span ng-show='data._jsonParameters.oldInstanceType' class='audit-text-value'>{{data._jsonParameters.oldInstanceType}}</span><span> to </span> <span class='audit-text-value'>{{data._jsonParameters.instanceType}}</span></span>",
            "Install Certificate":              "<span><span class='audit-text-action-name'>Install Cloud Manager certificate</span></span>",
            "Add Key Manager Ca Certificate":   "<span><span class='audit-text-action-name'>Add key manager CA certificate </span></span>",
            "Update Key Manager Ca Certificate":"<span><span class='audit-text-action-name'>Update key manager CA certificate </span></span>",
            "Update Client Certificate":        "<span><span class='audit-text-action-name'>Renew ONTAP certificate </span></span>",
            "Delete Key Manager Ca Certificate":"<span><span class='audit-text-action-name'>Delete key manager CA certificate </span></span>",
            "Add Key Manager":                  "<span><span class='audit-text-action-name'>Add key manager </span><span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Add Key Manager To Vsa":           "<span><span class='audit-text-action-name'>Add key manager to Cloud Ontap </span><span class='audit-text-value'>{{data._jsonParameters.keyManagerIp}}</span> <span class='audit-text-action-name'></span></span>",
            "Delete Key Manager From Vsa":      "<span><span class='audit-text-action-name'>Delete key manager from Cloud Ontap </span><span class='audit-text-value'>{{data._jsonParameters.keyManagerIp}}</span><span class='audit-text-action-name'></span></span>",
            "Update Key Manager":               "<span><span class='audit-text-action-name'>Update key manager </span><span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Delete Key Manager":               "<span><span class='audit-text-action-name'>Delete key manager </span><span class='audit-text-value'>{{data._jsonParameters.name}}</span></span>",
            "Generate Csr":                     "<span><span class='audit-text-action-name'>Generate CSR </span></span>",
            "Update System Image":              "<span><span class='audit-text-action-name'>Update system image</span> on working environment <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span><span ng-if='data._jsonParameters.fromVersion'> from <span class='audit-text-value'>{{data._jsonParameters.fromVersion}}<span ng-if=\"data._jsonParameters.fromImage && data._jsonParameters.updateType === 'LOCAL_IMAGE'\"> ({{data._jsonParameters.fromImage}}) </span></span><span ng-if='data._jsonParameters.toVersion'> to <span class='audit-text-value'>{{data._jsonParameters.toVersion}}<span ng-if=\"data._jsonParameters.updateParameter && data._jsonParameters.updateType === 'LOCAL_IMAGE'\"> ({{data._jsonParameters.updateParameter}}) </span></span></span></span></span>",
            "Working Environments Report":      "<span><span class='audit-text-action-name'>Working environments report</span></span>",
            "Update Image Cloud Ontap Metadata":"<span><span class='audit-text-action-name'>Update image Cloud ONTAP metadata</span></span>",
            "Update Cloud Ontap Metadata":      "<span><span class='audit-text-action-name'>Update Cloud ONTAP metadata</span></span>",
            "Setup Cifs Configuration":         "<span><span class='audit-text-action-name'>Setup CIFS Configuration</span></span>",
            "Backup Ontap Configuration":       "<span><span class='audit-text-action-name'>Backup Cloud ONTAP Configuration</span></span>",
            "Activate Ontap Configuration":     "<span><span class='audit-text-action-name'>Set Cloud ONTAP configuration Target</span></span>",
            "Scheduled Cloud ONTAP Stop":       "<span><span class='audit-text-action-name'>Scheduled Cloud ONTAP Stop</span></span>",
            "Scheduled Cloud ONTAP Start":      "<span><span class='audit-text-action-name'>Scheduled Cloud ONTAP Start</span></span>",
            "Set Schedules":                    "<span><span class='audit-text-action-name'>Set Cloud ONTAP Start-Stop Schedules</span></span>",
            "Restore During Setup":             "<span><span class='audit-text-action-name'>Initial Setup</span><span> by restoring from existing Cloud Manager installation</span> <span class='audit-text-value'>{{data._jsonParameters.url}}</span></span>",
            "Generate Keys And Certificate Request":"<span><span class='audit-text-action-name'>Generate Certificate Signing Request</span></span>",
            "Install Signed Certificate":        "<span><span class='audit-text-action-name'>Install Signed Certificate</span></span>",
            "Install External Signed Certificate":"<span><span class='audit-text-action-name'>Install External Signed Certificate</span></span>",
            "Create Aws Ha Working Environment": "<span><span class='audit-text-action-name'>Create new highly available working environment</span> <span class='audit-text-value'>{{data._jsonParameters.name}}</span> of type Cloud ONTAP</span>",
            "Change Svm Name":                   "<span><span class='audit-text-action-name'>Modify SVM name</span> of Cloud ONTAP<span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span> to <span class='audit-text-value'>{{data._jsonParameters.svmName}}</span></span>",
            "Modify Writing Speed":              "<span><span class='audit-text-action-name'>Modify write speed </span> of Cloud ONTAP <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span> to <span class='audit-text-value'>{{data._jsonParameters.writingSpeedState| lowercase | _.capitalize}}</span></span>",
            "Move Volume":                       "<span><span class='audit-text-action-name'>Move Volume</span><span class='audit-text-value'> {{data._jsonParameters.volumeName}}</span> of <span class='audit-text-value'>{{data._jsonParameters.workingEnvironmentName}}</span> to <span ng-if='data._jsonParameters.createTargetAggregate'>a new</span> aggregate <span class='audit-text-value'>{{data._jsonParameters.targetAggregateName}}</span></span>"
        };
    });
}());
