(function(){
    "use strict";

    angular.module("noc").controller("AddTrustedCAController", function($scope, $timeout, $rootScope, nocUploader, nocHttp, nocHttpsResourcesService, pidgeon){

        nocUploader.call($scope, nocHttp);

        $scope.uploadCertificateFile = function(e) {
            $timeout(function() {
                $scope.certificateFile = e.files[0];
                $scope.certificateFileName = $scope.certificateFile.name;
            }, 1); //timeout actives digest cycle so that file name appears instantly in input box
        };

        $scope.onUploadTrustedCA = function() {
            $("#hiddenCertificateInputButton").click();
        };

        $scope.uploadAndInstallTrustedCA = function() {
            var uploadFormFieldTrustedCA, fileTrustedCAFileNameFieldName, uploadUrl;
            uploadFormFieldTrustedCA = 'certificate';
            fileTrustedCAFileNameFieldName = 'filename';
            uploadUrl = '/occm/key-store/trusted-certificate-file';

            var descriptors = [{
                fieldName: fileTrustedCAFileNameFieldName,
                file: $scope.certificateFile,
                uploadFormField: uploadFormFieldTrustedCA
            }];

            $scope.upload("uploading certificate file", descriptors, uploadUrl)
                .then(function() {
                    if ($rootScope.appState !== 'failed') {
                        $scope.modalOk();
                    } else {
                        nocHttpsResourcesService.restartOCCM(nocHttp, pidgeon);
                    }
                });
        };
    });
}());
