(() => {
    'use strict';

    angular.module('noc').controller('UploadLicenseFileController', ($scope, nocHttp, workingEnvironmentResource) => {
        $scope.initialize = () => {
            $scope.licenseNocHttp = nocHttp;
            $scope.evalLicense = _.get($scope.selectedWorkingEnvironment, 'ontapClusterProperties.evaluation');
        };

        $scope.uploadLicenseFile = () => {
            let nodeOneLicense, nodeTwoLicense;
            if ($scope.selectedWorkingEnvironment.isHA) {
                nodeOneLicense = $scope.providedLicenseNode1;
                nodeTwoLicense = $scope.providedLicenseNode2;
            } else {
                nodeOneLicense = $scope.providedLicense;
            }
            workingEnvironmentResource.uploadLicenseFile(nocHttp, $scope.selectedWorkingEnvironment, nodeOneLicense, nodeTwoLicense)
                .then(() => {
                    workingEnvironmentResource.updateWorkingEnvironmentStatus($scope.selectedWorkingEnvironment, 'updating');
                    $scope.modalOk();
                });
        };

        $scope.initialize();
    });
})();
