(() => {
    'use strict';
    angular.module('noc').controller('VolumeInformationController', ($scope, $stateParams, $filter) => {
        $scope.loaded = false;

        $scope.initialize = () => {
            $scope.selectedVolume = _.cloneDeep(_.find($scope.volumes, {
                name: $stateParams.selectedVolumeName,
                svmName: $stateParams.selectedVolumeSVM
            }));

            //Init volume for display:
            $scope.selectedVolume._displayDeduplicationSpaceSaved = $scope.selectedVolume.compressionSpaceSaved ?
                $filter('normalizedCapacity')($scope.selectedVolume.compressionSpaceSaved, 2, true) :
                'None';
            $scope.selectedVolume._displayCompressionSpaceSaved = $scope.selectedVolume.deduplicationSpaceSaved ?
                $filter('normalizedCapacity')($scope.selectedVolume.deduplicationSpaceSaved, 2, true) :
                'None';

            $scope.loaded = true;
        };

        $scope.$watch('volumes', (volumes) => {
            /* istanbul ignore else */
            if (volumes) {
                $scope.initialize();
            }
        });
    });
})();
