(function () {
    "use strict";

    angular.module("noc").controller("MediatorUpgradeVersionController", function ($scope, BaseVirginStep, $state, workingEnvironmentResource, nocHttp, nocUtil, pidgeon) {
        BaseVirginStep.call($scope);

        $scope.initialize = function () {
            var pathPrefix = nocUtil.workingEnvironmentTypeToRequestPathPrefix($state.params.type, $state.params.provider);
            workingEnvironmentResource.getVSAByPublicId(nocHttp, $state.params.workingEnvironmentId, pathPrefix, true)
                .then(function(workingEnvironment){
                    $scope.wizardController.workingEnvironment = workingEnvironment;
                    $scope.mediatorToUpgradeVersion = workingEnvironment.haProperties.mediatorVersionsToUpdate[0];
                    $scope.currentMediatorVersion =  workingEnvironment.haProperties.mediatorVersionInfo.version;
                });
        };

        $scope.upgrade = function(workingEnvironment){
            workingEnvironmentResource.changeMediatorVersion(nocHttp, workingEnvironment, {})
                .then(function(){
                    pidgeon.success("Working environment upgrade successfully triggered.");
                    $scope.wizardController.wizardCompletedSucssesfully = true;
                    $scope.exit();
                });
        };

        $scope.initialize();
    });
}());
