(() => {
    'use strict';

    angular.module('noc').controller('CloudOntapUpgradeVersionController', function ($scope, BaseVirginStep, $state, workingEnvironmentResource, nocHttp, nocUtil) {
        BaseVirginStep.call($scope);

        $scope.$on('$stateChangeSuccess', (event, toState) => {
            if (toState.name === $scope.virginStuff.stateName) {
                $scope.wizardController.releaseNotesRead = false;
            }
        });

        $scope.setShowOlderVersions = (showOlderVersions) => {
            $scope.showOlderVersions = showOlderVersions;
        };

        $scope.selectVersion = (version) => {
            $scope.wizardController.selectedVersion = version;
            $state.go($scope.virginStuff.stateName);
        };

        $scope.initialize = () => {
            if (!$scope.wizardController.workingEnvironment) {
                const pathPrefix = nocUtil.workingEnvironmentTypeToRequestPathPrefix($state.params.type, $state.params.provider);
                workingEnvironmentResource.getVSAByPublicId(nocHttp, $state.params.workingEnvironmentId, pathPrefix, _.includes(pathPrefix, '/ha'))
                    .then((workingEnvironment) => {
                        $scope.wizardController.versionsAvailable = workingEnvironment.ontapClusterProperties.upgradeVersions;
                        $scope.wizardController.workingEnvironment = workingEnvironment;
                        $scope.wizardController.workingEnvironment._pathPrefix = pathPrefix;
                        $scope.wizardController.selectedVersion = $scope.wizardController.versionsAvailable[0];
                        $scope.currentVersion = workingEnvironment.ontapClusterProperties.ontapVersion;
                        $scope.hasMediatorUpgradeOption = workingEnvironment.haProperties && workingEnvironment.haProperties.mediatorVersionsToUpdate.length > 0;
                    });
            } else {
                $scope.currentVersion = $scope.wizardController.workingEnvironment.ontapClusterProperties.ontapVersion;
                $scope.hasMediatorUpgradeOption = $scope.wizardController.workingEnvironment.haProperties && $scope.wizardController.workingEnvironment.haProperties.mediatorVersionsToUpdate.length > 0;
            }
        };

        $scope.initialize();
    });
})();
