(() => {
    'use strict';

    angular.module('noc').controller('CloudSyncActivationVolumesStepController', ($scope, BaseVirginStep, nocHttp,
                                                                                  nocUtil, volumesResource) => {
        BaseVirginStep.call($scope);

        $scope.initialize = function initialize() {
            $scope.controllerData = {
                selectAll: $scope.wizardController.type === 'VSA' || $scope.wizardController.type === 'HA',
                search: {name: ''}
            };

            const pathPrefix = nocUtil.workingEnvironmentTypeToRequestPathPrefix($scope.wizardController.type, $scope.wizardController.provider);

            volumesResource.getVolumes(nocHttp, $scope.wizardController.workingEnvironmentId, pathPrefix)
                .then((volumes) => {
                    _.remove(volumes, (volume) => {
                        return volume.volumeType === 'dp' || volume.securityStyle === 'ntfs' ||
                            volume.state === 'offline' || volume.moving || !volume.junctionPath;
                    });
                    $scope.volumes = volumes;
                    $scope.selectableVolumes = _.filter($scope.volumes, 'mountPoint');
                    $scope.onSelectAll();
                });
        };

        $scope.onSelectAll = () => {
            _.forEach($scope.selectableVolumes, (volume) => {
                volume.selected = $scope.controllerData.selectAll;
            });
            $scope.onSelectionChange();
        };

        $scope.onSelectionChange = () => {
            const selectedVolumesObjects = _.filter($scope.volumes, 'selected');

            $scope.controllerData.selectAll = _.every($scope.selectableVolumes, 'selected');
            $scope.controllerData.selectedVolumesTotalUsedSize = nocUtil.sumCapacityUsingField(selectedVolumesObjects, 'usedSize');
            $scope.wizardController.selectedVolumes = _.map(selectedVolumesObjects, 'name');
        };

        $scope.initialize();
    });
})();
