(function () {
    'use strict';

    angular.module('noc').controller('CreateNewVolumeIopsStepController', function ($scope, nocUI, nocAdvancedAllocationService, 
                                                                                    nocHttp, pidgeon, Constants) {
        $scope.initializeController = function initializeController() {
            nocAdvancedAllocationService.getAggregates(nocHttp, pidgeon, $scope.wizardController.selectedWorkingEnvironment)
                .then((aggregates) => {
                    const aggregatesWithIo1DiskType = _.filter(aggregates, (aggr) => {
                        return _.includes(aggr._providerVolumeType, $scope.wizardController.selectedTier.name);
                    });
                    $scope.existingIops = _.uniq(_.map(aggregatesWithIo1DiskType, 'providerVolumes[0].iops'));
                });
            $scope.maxIopsValue = Constants.awsIopsLimitPerVolume;
        };

        $scope.saveAddVolume = function saveAddVolume() {
            if (!$scope.isValid()) {
                nocUI.handleErrorsInWizard(true);
            } else {
                $scope.createVolumeOnVsa();
            }
        };

        $scope.selectRecommendedIops = function selectRecommendedIops(index) {
            $scope.wizardController.iops = $scope.existingIops[index];
        };

        $scope.initializeController();
    });
}());
