(() => {
    'use strict';

    angular.module('noc').controller('PortalAfterMigrationController', ($scope, $rootScope, $window, intercomNotifier, nocAuth0Service, nocLocalStorage) => {
        $rootScope.externalConfig = {
            'intercom_prod_app_id': $rootScope.supportServices.intercomAppId
        };
        intercomNotifier.boot();

        $scope.handleLogin = () => {
            handleOperation();
        };

        $scope.goToResetPassword = () => {
            handleOperation(true);
        };

        function handleOperation(resetPassword) {
            nocLocalStorage.LOGINN_AFTER_MIGRATION.save(true);
            nocAuth0Service.portalUserAuthentication(undefined, resetPassword)
                .then(() => {
                    $window.location.href = _($window.location.href)
                        .replace(/#.*/, '')
                        .replace(/\?.*/, '');
                }).catch();
        }
    });
})();
