(function() {
    "use strict";
    angular.module("noc.components").directive('nocSuperDuper', function($timeout, $rootScope){
        var focusFirstInput = function(uiView) {
            uiView.find('[autofocus]').first().focus();
        };

        var inScrolling = false;

        return {
            restrict: 'E',
            scope: {},
            link: function (scope, element) {

                var calcScrollPoint = function(theView) {
                    const topFillHeight = $('[noc-match-header-height]').height();
                    const hasBorder = !theView.find('.no-border').length;
                    var volumeViewOffset = $rootScope.appView === 'volume-view' ? 75 : 0;
                    return theView.offset().top - (topFillHeight + 25) + (hasBorder ? 8 : 0) - volumeViewOffset;
                };

                var theView = element.closest("[ui-view]");
                $timeout(function(){
                    if (theView.length){
                        $("html, body").animate({ scrollTop: calcScrollPoint(theView) }, 300, "linear", function() {
                            focusFirstInput(theView);
                        });
                    }
                }, 500);


                scope.$on("$destroy", function(){
                    var closestUiView = element.closest("[ui-view]").parent().closest("[ui-view]");
                    $timeout(function() {
                        if (closestUiView.length) {
                            var scrollPoint = calcScrollPoint(closestUiView);
                            if (!inScrolling) {
                                inScrolling = true;
                                $("html, body").animate({ scrollTop: scrollPoint }, 300, "linear", function () {
                                    focusFirstInput(closestUiView);
                                    inScrolling = false;
                                });
                            }
                        }
                    });
                });
            }
        };
    });

    angular.module("noc.components").directive('nocVirginBottomFill', function($timeout){
        return {
            restrict: 'A',
            scope: {},
            link: function (scope, element) {
                var resizeHandler = function() {
                    $timeout(function() {
                        var theUiViews = element.siblings("[ui-view]").find('[ui-view]'),
                            currentView = theUiViews.eq(theUiViews.length - 2) || theUiViews.eq(theUiViews.length - 1),
                            windowHeight = $(window).height(),
                            headerHeight = element.siblings("[noc-match-header-height]").height();
                        var currentViewHeight = currentView.height();
                        var resultHeight = windowHeight - headerHeight - currentViewHeight;

                        element.height(resultHeight);
                    }, 1000);
                };

                resizeHandler();

                scope.$on('$stateChangeSuccess', resizeHandler);
                $(window).on('resize', resizeHandler);

                scope.$on("$destroy", function(){
                    $(window).off('resize', resizeHandler);
                });
            }
        };
    });
})();
