(function () {
    'use strict';

    angular.module('noc').controller('VirginCreateWorkingEnvironmentDiskSizeStepController', function ($scope, configService, nocHttp, Constants) {
        $scope.initialize = function () {
            $scope.allowDiskSizeSelection = true;

            configService.getConfig(nocHttp, ['ebsSizeToPiopsRatio'])
                .then(function (configResponse) {
                    $scope.ebsSizeToPiopsRatio = configResponse.ebsSizeToPiopsRatio;
                    $scope.onDiskSizeChange();
                });
        };

        $scope.onDiskSizeChange = function onDiskSizeChange() {
            $scope.wizardController.providerVolumeSizeGB = $scope.wizardController.providerVolumeSize.unit === 'GB' ? $scope.wizardController.providerVolumeSize.size : $scope.wizardController.providerVolumeSize.size * 1024;
            $scope.maxIopsValue = _.min([Constants.awsIopsLimitPerVolume, $scope.wizardController.providerVolumeSizeGB * $scope.ebsSizeToPiopsRatio]);
        };

        $scope.initialize();
    });
}());
