(() => {
    'use strict';

    angular.module('noc').controller('VirginCreateGcpAccountsController', ($scope, nocHttp, $state, nocUI,
                                                                         CloudProviderAccountResource, nocDialog) => {

        $scope.initialize = () => {
            $scope.gcpAccountRequest = {};
            CloudProviderAccountResource.getAccounts(nocHttp)
                .then((accounts) => {
                    $scope.wizardController.gcpStorageAccounts = accounts.gcpStorageAccounts;
                    if (!$scope.wizardController.selectedGcpAccount) {
                        $scope.wizardController.selectedGcpAccount = accounts.gcpStorageAccounts[0];
                    }
                    if ($scope.wizardController.failedRequest) {
                       $scope.wizardController.selectedGcpAccount = _.find($scope.wizardController.gcpStorageAccounts, {publicId: $scope.wizardController.failedRequest.gcpStorageAccount});
                    }
                });
        };

        $scope.openLearnMoreDialog = () => {
            nocDialog.confirm('', 'assets/templates/cloud-provider-accounts/gcp-learn-more.html', {
                width: 890,
                fromTop: '20%'
            });
        };

        $scope.next = () => {
            if ($scope.wizardController.selectedGcpAccount) {
                $state.go('.review');
            } else {
                if ($scope.isValid()) {
                    CloudProviderAccountResource.createAccount(nocHttp, 'gcp', $scope.gcpAccountRequest.accountName, $scope.gcpAccountRequest.providerKeys)
                        .then((account) => {
                            $scope.wizardController.gcpStorageAccounts = [account];
                            $scope.wizardController.selectedGcpAccount = account;
                            $state.go('.review');
                        });
                } else {
                    nocUI.handleFormValidity($scope.VirginWizardForm);
                }
            }
        };

        $scope.skip = () => {
            $scope.wizardController.gcpAccountSkipped = true;
            $state.go('.review');
        };

        $scope.initialize();
    });
})();
