(function(){
    "use strict";

    angular.module("noc").controller("VirginCreateWorkingEnvironmentHAFloatingIpController", function($scope){

        $scope.initialize = function() {
            $scope.wizardController.haParameters = $scope.wizardController.haParameters ? $scope.wizardController.haParameters : {};
            $scope.popoverText = "For example, if you are using CIDR blocks 10.0.0.0/16 and 172.31.0.0/16 in the region, then you could specify " +
            "the following floating IP addresses: 192.168.10.2, 192.168.10.3, and 192.168.10.4.<br><br>" +
            "You do not need to specify floating IP addresses for iSCSI. iSCSI data LIFs are created by default with " +
            "static IP addresses, rather than floating IP addresses. Cloud Volumes ONTAP uses multipath I/O (MPIO) and Asymmetric " +
            "Logical Unit Access (ALUA) to provide high availability for iSCSI.";
            if($scope.wizardController.failedRequestType) {
                _.set($scope.wizardController, 'haParameters.clusterFloatingIP', $scope.wizardController.failedRequest.haParams.clusterFloatingIP);
                $scope.wizardController.haParameters.dataFloatingIP = $scope.wizardController.failedRequest.haParams.dataFloatingIP;
                $scope.wizardController.haParameters.dataFloatingIP2 = $scope.wizardController.failedRequest.haParams.dataFloatingIP2;
                $scope.wizardController.haParameters.svmFloatingIP = $scope.wizardController.failedRequest.haParams.svmFloatingIP;
            }
        };

        $scope.$on("$destroy", function () {
            $scope.wizardController.backupStepData("ha-floating-ip", {
                clusterFloatingIP: $scope.wizardController.haParameters.clusterFloatingIP,
                dataFloatingIP: $scope.wizardController.haParameters.dataFloatingIP,
                dataFloatingIP2: $scope.wizardController.haParameters.dataFloatingIP2
            });



            $scope.wizardController.haParameters.clusterFloatingIP = null;
            $scope.wizardController.haParameters.dataFloatingIP = null;
            $scope.wizardController.haParameters.dataFloatingIP2 = null;

        });

        _.assignIn($scope.wizardController.haParameters, $scope.wizardController.getStepData("ha-floating-ip"));
        $scope.initialize();

    });
}());
