(function () {
    "use strict";

    angular.module("noc").controller("HaDeploymentModelController", function ($scope, $state) {

        $scope.initialize = function() {
            if( $scope.wizardController.failedRequestType ) {
                $scope.wizardController.failoverMode = _.get($scope.wizardController, 'failedRequest.haParams.failoverMode');
                $scope.disablePrivateIp = $scope.wizardController.failedRequestType && $scope.wizardController.failoverMode === 'FloatingIP';
                $scope.disableFloatingIp = $scope.wizardController.failedRequestType && $scope.wizardController.failoverMode === 'PrivateIP';
            }
        };

        $scope.selectHaDeploymentModel = function (failoverMode) {
            $scope.wizardController.failoverMode = failoverMode;
            $state.go($scope.wizardController.path["choose-ha-deployment-model"] + getNextStep(failoverMode));
        };

        function getNextStep(failoverMode){
            return failoverMode === "FloatingIP" ? '.ha-vpc' : '.vpc';
        }

        $scope.next = function(){
            $scope.wizardController.next(getNextStep($scope.wizardController.failoverMode));
        };

        $scope.initialize();

    });
}());
