(function(){
    "use strict";

    angular.module("noc").controller("VirginOnPremClusterStepController", function($scope, nocUI, nocHttp, $state, BaseVirginStep, Constants){
        BaseVirginStep.call($scope);

        $scope.wizardController.title = "Discover ONTAP Cluster";
        $scope.dataONTAPLocations = _.values(Constants.dataONTAPLocations);
        $scope.wizardController.dataONTAPLocation = "ON_PREM";
        let weType = _.get($scope.wizardController, 'workingEnvironmentTypeAndProvider.type');
        if (weType === "SOFTL"){
            $scope.wizardController.dataONTAPLocation = "SOFTLAYER";
        }

        $scope.verifyCredentials = function() {
            if($scope.isValid()){
                nocHttp.get({
                    url: "/onprem/metadata/cluster-info",
                    headers: {
                        clusterAddress: $scope.wizardController.clusterAddress,
                        clusterUsername: $scope.wizardController.clusterUserName,
                        clusterPassword: $scope.wizardController.clusterPassword
                    }
                }, "verifying credentials", nocHttp.BLOCK)
                    .then(function (clusterInfo) {
                        $scope.wizardController.workingEnvironmentName = clusterInfo.clusterName;
                        $state.go(".details");
                    });
            }else{
                nocUI.handleErrorsInWizard(true);
            }
        };

        $scope.$on("$destroy", function(){
            $scope.wizardController.backupStepData("cluster", {
                clusterAddress : $scope.wizardController.clusterAddress,
                dataONTAPLocation: $scope.wizardController.dataONTAPLocation,
                clusterUserName : $scope.wizardController.clusterUserName,
                clusterPassword : $scope.wizardController.clusterPassword,
                workingEnvironmentName : $scope.wizardController.workingEnvironmentName
            });
            $scope.wizardController.clusterAddress = "";
            $scope.wizardController.clusterUserName = "";
            $scope.wizardController.clusterPassword = "";
            $scope.wizardController.workingEnvironmentName = "";
            $scope.wizardController.dataONTAPLocation = "";
        });

        $scope.wizardController.clusterUserName = "admin";
        _.assignIn($scope.wizardController, $scope.wizardController.getStepData("cluster"));

    });
}());
