(() => {
    'use strict';

    angular.module('noc').controller('SnapMirrorPolicyController', ($scope, nocHttp, $state, policyRules, nocPoliciesService) => {
        $scope.tab = 'default';
        $scope.defaultRules = policyRules.defaultRules;

        $scope.initialize = function () {
            nocPoliciesService.getPolicies(nocHttp, $scope.wizardController.sourceWorkingEnvironment.publicId, $scope.wizardController.targetWorkingEnvironment.publicId)
                .then(function (policies) {
                    nocPoliciesService.getSnapshotLabels(nocHttp, policies, $scope.wizardController.sourceWorkingEnvironment.publicId, $scope.wizardController.selectedVolume.svmName, $scope.wizardController.selectedVolume.name)
                        .then(function (policiesWithSnapshotsLabels) {
                            $scope.defaultPolicies = _.filter(policiesWithSnapshotsLabels, {isDefault: true});
                            $scope.policies = _.xor(policiesWithSnapshotsLabels, $scope.defaultPolicies);
                        });
                });
        };

        $scope.selectPolicy = (policy) => {
            if (!policy.isSupported) return;
            $scope.wizardController.policy = policy;
            if ($state.$current.data.name !== 'schedules') {
                $scope.wizardController.next('.schedules');
            }
        };

        $scope.$on("$destroy", function(){
            $scope.wizardController.backupStepData("policy", {
                policy: $scope.wizardController.policy
            });
            $scope.wizardController.policy = null;
        });

        _.assignIn($scope.wizardController, $scope.wizardController.getStepData("policy"));
        $scope.initialize();
    });
})();
