(() => {
    'use strict';

    angular.module('noc').factory('NocErrorResponse', ($filter) => {
        function ErrorResponse(error) {
            if (_.isString(error)) {
                try {
                    error = JSON.parse(error);
                } catch (error) {
                    _.noop();
                }
            }
            _.assign(this, error);

            if (_.isUndefined(error) || _.isUndefined(error.message) || !_.isString(error.message) || _.isEmpty(error.message)) {
                this.message = 'Server Fault: Unknown Error Response';
            }
        }

        ErrorResponse.prototype.messageForDisplay = function messageForDisplay() {
            return this.message + $filter('dateAndTime')(this.date);
        };

        return ErrorResponse;
    });
})();
