(() => {
    'use strict';
    angular.module('noc').service('systemResource', ($http, $rootScope) => {
        return (nocHttp) => {
            const defaultImplementation = (url, action, cache, httpUIBehavior) => {
                if (nocHttp) {
                    return nocHttp.get({url, cache}, action, httpUIBehavior);
                } else {
                    if (httpUIBehavior) throw new Error("SystemResource doesn't have an instance of nocHttp but called with nocHttp behavior parameter");

                    return $http.get(url, {cache})
                        .then((response) => response.data);
                }
            };

            return {
                //Parameter httpUIBehavior is relevant only if using nocHttp
                getInstancePlacement: (nocHttpUIBehavior, overrideCache) => {
                    return defaultImplementation('/occm/system/occm-instance-placement', 'retrieving instance placement', !overrideCache, nocHttpUIBehavior);
                },

                getAvailableVersions: (nocHttpUIBehavior) => {
                    return defaultImplementation('/occm/system/available-update-versions', 'retrieving available versions', false, nocHttpUIBehavior);
                },

                getSupportServices: (nocHttpUIBehavior) => {
                    return defaultImplementation('/occm/system/support-services', 'retrieving support services', false, nocHttpUIBehavior)
                        .then((supportServices) => {
                            $rootScope.supportServices = supportServices;
                            $rootScope._isPortalAuthenticationMode = $rootScope.supportServices.portalService && $rootScope.supportServices.portalService.usePortalAuthentication;

                            return supportServices;
                        });
                }
            };
        };
    });
})();
