(() => {
    'use strict';

    angular.module('noc').config(($stateProvider, virginWizardTreeBuilder) => {
        const wizardSteps = [
            {
                url: '/create-new-aggregate-wizard?workingEnvironmentId&type&provider',
                name: 'create-new-aggregate-wizard',
                controller: 'VirginWizardController',
                templateUrl: 'assets/templates/wizards/virgin-wizard.html',
                resolve: {
                    layoutOptions: () => {
                        return {
                            title: 'Create new aggregate'
                        };
                    },
                    exitOptions: /*@ngInject*/ ($stateParams) => {
                        return {
                            exit: function exit() {
                                this.checkAndSetState('main.working-environments.monitoring.index', {
                                    workingEnvironmentId: $stateParams.workingEnvironmentId,
                                    type: $stateParams.type,
                                    provider: $stateParams.provider,
                                    gadget: 'advancedAllocation'
                                });
                            }
                        };
                    },
                    initOptions: /*@ngInject*/ ($stateParams) => {
                        return {
                            firstStep: 'create-new-aggregate-wizard.details',
                            workingEnvironmentId: $stateParams.workingEnvironmentId,
                            type: $stateParams.type,
                            provider: $stateParams.provider
                        };
                    }
                }
            },
            {
                name: 'details',
                controller: 'CreateNewAggregateDetailsStepController',
                wizardTemplateUrl: 'assets/templates/wizards/create-new-aggregate/details.html'
            },
            {
                name: 'tiering',
                controller: 'CreateNewAggregateTieringStepController',
                wizardTemplateUrl: 'assets/templates/wizards/create-new-aggregate/tiering.html'
            },
            {
                name: 'disk-size-and-iops',
                controller: 'CreateNewAggregateDiskSizeAndIopsStepController',
                wizardTemplateUrl: 'assets/templates/wizards/create-new-aggregate/disk-size-and-iops.html'
            }
        ];

        const wizardTree = {
            'create-new-aggregate-wizard': {
                details: {
                    tiering: {
                        'disk-size-and-iops': true
                    },
                    'disk-size-and-iops': true
                }
            }
        };

        virginWizardTreeBuilder($stateProvider, wizardTree, wizardSteps);
    });
})();
