(function () {
    'use strict';

    angular.module('noc').config(function ($stateProvider, virginWizardTreeBuilder) {
        var wizardSteps = [
            {
                url: '/create-new-volume-wizard?workingEnvironmentId&type&provider&aggregateName&providerVolumeType&capacityTier&iops&from&gadget',
                name: 'create-new-volume-wizard',
                controller: 'VirginWizardController',
                templateUrl: 'assets/templates/wizards/virgin-wizard.html',
                resolve: {
                    layoutOptions: function () {
                        return {
                            title: 'Create new volume'
                        };
                    },
                    exitOptions: /*@ngInject*/function ($stateParams) {
                        return {
                            exit: function exit() {
                                this.checkAndSetState($stateParams.from, {
                                    workingEnvironmentId: $stateParams.workingEnvironmentId,
                                    type: $stateParams.type,
                                    provider: $stateParams.provider,
                                    gadget: $stateParams.gadget
                                });
                            }
                        };
                    },
                    initOptions: /*@ngInject*/function ($stateParams) {
                        return {
                            firstStep: 'create-new-volume-wizard.details',
                            workingEnvironmentId: $stateParams.workingEnvironmentId,
                            from: $stateParams.from,
                            syncToS3: $stateParams.syncToS3,
                            type: $stateParams.type,
                            provider: $stateParams.provider
                        };
                    }
                }
            },
            {
                name: 'details',
                controller: 'CreateNewVolumeDetailsStepController',
                wizardTemplateUrl: 'assets/templates/wizards/create-new-volume/details.html'
            },
            {
                name: "cifs",
                controller: "CifsConfigurationsController",
                wizardTemplateUrl: 'assets/templates/wizards/create-new-volume/cifs.html'
            },
            {
                name: 'usageProfile',
                controller: 'CreateNewVolumeUsageProfileStepController',
                wizardTemplateUrl: 'assets/templates/wizards/create-new-volume/usage-profile.html'
            },
            {
                name: 'iops',
                controller: 'CreateNewVolumeIopsStepController',
                wizardTemplateUrl: 'assets/templates/wizards/create-new-volume/iops.html'
            }
        ];

        var wizardTree = {
            'create-new-volume-wizard': {
                details: {
                    cifs: {
                        usageProfile: {
                            iops: true
                        }
                    },
                    usageProfile: {
                        iops: true
                    }
                }
            }
        };

        virginWizardTreeBuilder($stateProvider, wizardTree, wizardSteps);
    });
}());
