(() => {
    'use strict';
    angular.module('noc').config(($stateProvider, virginWizardTreeBuilder) => {
        const wizardSteps = [
            {
                url: '/mediator-upgrade?slTenantId&from&workingEnvironmentId&type&provider&first',
                name: 'mediator-upgrade',
                controller: 'VirginWizardController',
                templateUrl: 'assets/templates/wizards/virgin-wizard.html',
                resolve: {
                    layoutOptions: () => {
                        return {
                            title: 'New Upgrade'
                        };
                    },
                    exitOptions: /*@ngInject*/function exitOptions($stateParams) {
                        return {
                            exit: function exit() {
                                if ($stateParams.from) {
                                    this.checkAndSetState($stateParams.from, {workingEnvironmentId: $stateParams.workingEnvironmentId});
                                } else {
                                    this.checkAndSetState('main');
                                }
                            }
                        };
                    },
                    initOptions: () => {
                        return {
                            firstStep: 'mediator-upgrade.init'
                        };
                    }
                }
            },
            {
                name: 'init',
                controller: 'CloudOntapUpgradeInitController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-ontap-upgrade/init.html'
            },
            {
                name: 'eula',
                controller: 'CloudOntapUpgradeEulaController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-ontap-upgrade/mediator-eula.html'
            },
            {
                name: 'cifs',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-ontap-upgrade/mediator-cifs-locks.html'
            },
            {
                name: 'version',
                controller: 'MediatorUpgradeVersionController',
                wizardTemplateUrl: 'assets/templates/wizards/cloud-ontap-upgrade/mediator-version.html'
            }
        ];

        const versionEnding = {
            version: true
        };

        const wizardTree = {
            'mediator-upgrade': {
                init: {
                    eula: versionEnding,
                    cifs: {
                        eula: versionEnding
                    }
                }
            }
        };

        virginWizardTreeBuilder($stateProvider, wizardTree, wizardSteps);
    });
})();
