(() => {
    'use strict';
    angular.module('noc').config(($stateProvider, virginWizardTreeBuilder) => {
        const steps = [
            {
                name: 'remove-we-wizard',
                url: '/remove-we-wizard?from',
                controller: 'VirginWizardController',
                templateUrl: 'assets/templates/wizards/virgin-wizard.html',
                resolve: {
                    layoutOptions: () => {
                        return {
                            title: 'Remove working environment from Cloud Manager'
                        };
                    },
                    exitOptions: /*@ngInject*/function exitOptions($stateParams) {
                        return {
                            exit: function exit() {
                                this.checkAndSetState($stateParams.from || 'main');
                            }
                        };
                    },
                    initOptions: function initOptions() {
                        return {
                            firstStep: 'remove-we-wizard.select-we'
                        };
                    }
                }
            },
            {
                name: 'select-we',
                controller: 'RemoveWeSelectWEController',
                wizardTemplateUrl: 'assets/templates/wizards/removewe/select-we.html'
            },
            {
                name: 'review',
                controller: 'RemoveWeReviewController',
                wizardTemplateUrl: 'assets/templates/wizards/removewe/review.html'
            }
        ];

        const tree = {
            'remove-we-wizard': {
                'select-we': {
                    review: true
                }
            }
        };

        virginWizardTreeBuilder($stateProvider, tree, steps);
    });
})();
