(() => {
    'use strict';

    angular.module('noc').config(($stateProvider, virginWizardTreeBuilder) => {
        var wizardSteps = [
            {
                url: "/create-volume-wizard",
                name: "create-volume-wizard",
                controller: 'VirginWizardController',
                templateUrl: 'assets/templates/wizards/vv-virgin-wizard.html',
                resolve: {
                    layoutOptions: function () {
                        return {
                            title: "Create Volume"
                        };
                    },
                    exitOptions: /*@ngInject*/function ($stateParams, $rootScope) {
                        return {
                            exit: function exit() {
                                $rootScope.showCreateFirstVolumeScreen = false;
                                if ($stateParams.from) {
                                    this.checkAndSetState($stateParams.from, {workingEnvironmentId: $stateParams.workingEnvironmentId});
                                } else {
                                    this.checkAndSetState('volume-view.volumes');
                                }
                            }
                        };
                    },
                    initOptions: function () {
                        return {
                            firstStep: "volume-view.create-volume-wizard.choose"
                        };
                    }
                }
            },
            {
                name: "choose",
                controller: "VolumeViewCreateVolumeChooseController",
                wizardTemplateUrl: 'assets/templates/wizards/vv-create-volume/vv-cv-choose.html'
            },
            {
                name: "diagram",
                controller: "VolumeViewEmptyController",
                wizardTemplateUrl: 'assets/templates/wizards/vv-create-volume/vv-cv-diagram.html'
            },
            {
                name: "details",
                controller: "VolumeViewAddVolumeController",
                wizardTemplateUrl: 'assets/templates/wizards/vv-create-volume/vv-cv-details.html'
            },
            {
                name: 'nodes-and-mediator',
                controller: 'VolumeViewAddVolumeNodesAndMediatorController',
                wizardTemplateUrl: 'assets/templates/wizards/vv-create-volume/vv-cv-nodes-and-mediator.html'
            },
            {
                name: 'floating-ip',
                controller: 'VolumeViewAddVolumeFloatingIpsController',
                wizardTemplateUrl: 'assets/templates/wizards/vv-create-volume/vv-cv-floating-ip.html'
            }
        ];

        var wizardTree = {
            "create-volume-wizard": {
                choose: {
                    diagram: {
                        details: {
                            'nodes-and-mediator': {
                                'floating-ip': true
                            }
                        }
                    },
                    details: {
                        'nodes-and-mediator': {
                            'floating-ip': true
                        }
                    }
                }
            }
        };

        virginWizardTreeBuilder($stateProvider, wizardTree, wizardSteps, 'volume-view');
    });
})();
