const _ = require('lodash');
const fs = require('fs');

module.exports = ($, file, reporter) => {
    let errors = [];

    fs.readFile(file.path, 'utf8', (err, data) => {
        //The original regexp: /[^=!]==[^=]|!=[^=]/g finds only the == or != expressions. The contextRegexp finds the whole line containing it.
        const contextRegexp = /(.*)([^=!]==[^=]|!=[^=])(.*)/g;
        const violations = data.match(contextRegexp);
        errors = _.map(violations, (violationContext) => {
            return {context: _.trim(violationContext)};
        });

        reporter.report(
            'This file contains equality operators ("==" or "!="), use identity operators instead ("===" or "!=="):\n ${context}',
            errors,
            file);
    });
};
