const _ = require('lodash');
const iconStore = require('../../icon_store');

module.exports = ($, file, reporter) => {
    const errors = $('noc-icon').map((index, element) => {
        const name = $(element).attr('name');
        //Do not return error for an expression name of an icon
        if (_.startsWith(name, '{{')) return null;

        if (!iconStore.exists(name)) {
            return {
                name,
                element: $(element).toString()
            };
        }

        return null;
    });

    reporter.report(
        'noc-icon name attribute value "${name}" does not have a matching .svg file (in ${element})',
        errors,
        file);
};
