var regexps = require('../../../../server/src/main/resources/regex.json');

module.exports = function ($, file, reporter) {
    var errors = $('[noc-validation]').map(function (index, element) {
        var name = $(element).attr('noc-validation');

        if (!regexps[name]) {
            return {
                name: name,
                element: $(element).toString()
            };
        }

        return null;
    });

    reporter.report(
        'noc-validation value "${name}" is not configured in regex.json file (in ${element})',
        errors,
        file);
};
