var lazypipe = require('lazypipe');
var through = require('through-gulp');
var gulp = require('gulp');

var Task = require('../task');
var iconStore = require('../icon_store');

function fillIconsStore() {
    // returning the file stream
    return through(function(file, encoding,callback) {
        var relative = file.relative;
        var name = relative.substring(0,relative.length-4);
        var path = 'assets/images/icons/'+relative;

        iconStore.add(name, path);

        //pass the file the next pipe
        this.push(file);

        //notify we're done
        callback();
    });
}

module.exports = new Task(
    'icons',
    ['app/images/icons/**/*.svg'],
    true,
    lazypipe()
        .pipe(fillIconsStore)
        .pipe(gulp.dest,'./dist/assets/images/icons/')
);
