var lazypipe = require('lazypipe');
var gulp = require('gulp');
var inject = require('gulp-inject');
var gulpif = require('gulp-if');
const _ = require('lodash');

var program = require('../program');
var concatAndMinify = require('./pipes/concat_and_uglify');
var Task = require('../task');
var wiredep = require('wiredep').stream;


module.exports = new Task(
    'index',
    'app/index.html',
    true,
    lazypipe()
        .pipe(wiredep,{
            directory:'dist/assets/vendor',
            ignorePath : '../dist/'
        })
        .pipe(function () {
            // replaces the token with actual netapp js files
            return inject(
                gulp.src(['./dist/assets/scripts/**/*.js', '!dist/assets/scripts/noc-main.js'], {read: false}), {
                    transform: function (filename) {
                        var res = _.replace(filename, /\/dist\//, '');
                        return '<script src="' + res + '"></script>';
                    }
                }
            );
        })
        .pipe(function () {
            return gulpif(program.isProd, concatAndMinify());
        })
        .pipe(gulp.dest, './dist')
);
