var gulp = require('gulp');
var _ = require('lodash');
var Server = require('karma').Server;

var program = require('../program');

module.exports = {
    registerTask: function () {
        function runKarma(conf,done){
            var common = {configFile: __dirname+'/../../karma.conf.js'};

            function overrideDefaultsFromCommandLine(flagName){
                var flag = program[flagName];
                if(flag){
                    common[flagName] = _.isString(flag) ? _.split(flag, ',') : [];
                }
            }

            //override the reporters if specified in the command line
            overrideDefaultsFromCommandLine('reporters');
            overrideDefaultsFromCommandLine('browsers');

            new Server(_.assignIn(conf,common), done).start();
        }

        gulp.task('test', ['patterns','bower'], function (done) {
            runKarma({
                singleRun: true,
                reporters:['coverage','teamcity']
            },done);
        });

        gulp.task('tdd', ['patterns','bower'], function (done) {
            runKarma({
                reporters:['dots']
            },done);
        });
    }
};