var gulp = require('gulp');
var watcher = require('gulp-watch');
var connect = require('gulp-connect');
var gulpif = require('gulp-if');
var plumber = require('gulp-plumber');

var taskScripts = require('./scripts');
var taskIndex = require('./index');
var taskImages = require('./images');
var taskIcons = require('./icons');
var taskTemplates = require('./templates');
var taskVendor = require('./vendor');
var taskLess = require('./less');
var taskPatterns = require('./patterns');

function watch(task) {
    watcher(task.flatGlob,{verbose:true})
        .pipe(plumber()) //Prevent pipe breaking caused by errors from gulp plugins
        .pipe(task.pipe())
        .pipe(gulpif(task.reload, connect.reload()));
}

function pipe(task) {
    gulp.src(task.glob)
        .pipe(plumber()) //Prevent pipe breaking caused by errors from gulp plugins
        .pipe(task.pipe())
        .pipe(connect.reload());
}

module.exports = {
    registerTask: function () {
        gulp.task('watch', function () {
            watch(taskScripts);
            watch(taskIndex);
            watch(taskImages);
            watch(taskIcons);
            watch(taskTemplates);
            watch(taskVendor);

            //watch glob and src glob are not the same, so we can't use the watch() method
            watcher(taskLess.watchglob, {verbose:true}, function () {
                pipe(taskLess);
            });

            watcher(taskPatterns.watchglob, {verbose: true}, function() {
                pipe(taskPatterns);
            });

            //watch glob and src glob are not the same, and the pipe is conditional so we can't use the watch() method
            watcher(taskScripts.glob.prod, function (file) {
                if (file.event === 'add' || file.event === 'unlink') {
                    pipe(taskIndex);
                }
            });
        });
    }
};
