/*global magnifispec:true*/
var magnifispec;
(function () {
    magnifispec = {};

    var locals = {};

    var addVar = function (name, val) {
        locals[name] = val;
    };

    magnifispec.setup = function setup() {
        angular.mock.module('noc');
        angular.mock.module(function(_$provide_){
            locals.$provide = _$provide_;
        });
        inject(function (NocErrorResponse, _$rootScope_, _$controller_, _$q_, _nocUIFactory_, _nocFriendlyStore_, _$httpBackend_, _$window_, _nocBaseUrl_,
                         _$location_, _$timeout_, _nocNavigateAway_, _Messages_, _$compile_, _nocPoller_, _workingEnvironmentResource_, _replicationResource_, _nocUtil_,
                         _Messageable_, _pidgeonFactory_, _$cookies_, _$interval_, _$filter_, _nocDialog_, _actionRequiredResource_,
                         _nocUIMain_, _$document_, _$state_, _$stateParams_, _usageProfiles_, _Constants_, _ManifestMapper_, _replicationTableColumnsService_, _$log_, _BaseVirginStep_,
                         _Patterns_, _$templateCache_, _intercomNotifier_, _nocEncryptionResourcesService_, $q, _nocLocalStorage_, _nocLongPollingService_, _$http_, _systemResource_,
                         _nocHttpFactory_, _configService_, _auditResource_, _nocRegionsService_, _nocCurrentUserService_) {
            locals.$http = _$http_;
            locals.$compile = _$compile_;
            locals.errorResponse = new NocErrorResponse({message: "generic failure message", status: 400});
            locals.NocErrorResponse = NocErrorResponse;
            locals.$rootScope = _$rootScope_;
            locals.$controller = _$controller_;
            locals.$q = _$q_;
            locals.nocBaseUrl = _nocBaseUrl_;
            locals.nocFriendlyStore = _nocFriendlyStore_;
            locals.$httpBackend = _$httpBackend_;
            locals.$window = _$window_;
            locals.$location = _$location_;
            locals.$timeout = _$timeout_;
            locals.nocNavigateAway = _nocNavigateAway_;
            locals.Messages = _Messages_;
            locals.nocPoller = _nocPoller_;
            locals.nocDialog = _nocDialog_;
            locals.workingEnvironmentResource = _workingEnvironmentResource_;
            locals.replicationResource = _replicationResource_;
            locals.actionRequiredResource = _actionRequiredResource_;
            locals.systemResource = _systemResource_;
            locals.nocUtil = _nocUtil_;
            locals.Messageable = _Messageable_;
            locals.Constants = _Constants_;
            locals.$cookies = _$cookies_;
            locals.$interval = _$interval_;
            locals.$filter = _$filter_;
            locals.nocUIMain = _nocUIMain_;
            locals.$document = _$document_;
            locals.$state = _$state_;
            locals.$stateParams = _$stateParams_;
            locals.usageProfiles = _usageProfiles_;
            locals.ManifestMapper = _ManifestMapper_;
            locals.replicationTableColumnsService = _replicationTableColumnsService_;
            locals.$log = _$log_;
            locals.BaseVirginStep = _BaseVirginStep_;
            locals.Patterns = _Patterns_;
            locals.$templateCache = _$templateCache_;
            locals.intercomNotifier = _intercomNotifier_;
            locals.nocEncryptionResourcesService = _nocEncryptionResourcesService_;
            locals.nocLocalStorage = _nocLocalStorage_;
            locals.nocLongPollingService = _nocLongPollingService_;
            locals.configService = _configService_;
            locals.auditResource = _auditResource_;
            locals.nocRegionsService = _nocRegionsService_;
            locals.nocCurrentUserService = _nocCurrentUserService_;

            const awsRegions = {"us-east-1":{"name":"US East","location":"N. Virginia","code":"us-east-1"},"us-west-1":{"name":"US West","location":"N. California","code":"us-west-1"},"us-east-2":{"name":"US East","location":"Ohio","code":"us-east-2"},"eu-west-2":{"name":"EU","location":"London","code":"eu-west-2"},"eu-west-1":{"name":"EU","location":"Ireland","code":"eu-west-1"}};
            const azureRegions = {
                eastasia: {name: 'East Asia', location: 'Hong Kong', code: 'eastasia'},
                southeastasia: {name: 'Southeast Asia', location: 'Singapore', code: 'southeastasia'},
                westus: {name: 'West US', code: 'westus', location: 'California'}
            };
            jest.spyOn(locals.BaseVirginStep, "call").mockImplementation(() => {});
            jest.spyOn(locals.nocRegionsService, 'awsRegions').mockReturnValue(awsRegions);
            jest.spyOn(locals.nocRegionsService, 'azureRegions').mockReturnValue(azureRegions);
            jest.spyOn(_replicationTableColumnsService_, "getColumnsDef").mockReturnValue("null");

            locals.pidgeon = jasmine.createSpyObj("pidgeon", ['error', 'success', 'inProgress', 'kill', 'clear']);
            locals.pidgeon.serverErrorPrefix = "An error occurred while ";
            jest.spyOn(_pidgeonFactory_,'spawn').mockReturnValue(locals.pidgeon);

            const nocUI = locals.nocUI = jasmine.createSpyObj('nocUI', ['unblock', 'block', 'loading', 'unloading',
                'reloadSilently', 'handleFormValidity', 'clearFormValidity', 'ignoreFormValidity', 'logout',
                'formValidate', 'handleErrorsInWizard']);
            nocUI.block.mockReturnValue(nocUI.unblock);
            nocUI.loading.mockReturnValue(nocUI.unloading);
            nocUI.formValidate.mockReturnValue($q.when());
            jest.spyOn(_nocUIFactory_, 'spawn').mockReturnValue(nocUI);

            locals.timeoutFlushFailMessage = "No deferred tasks to be flushed";
            locals.backendFlushFailMessage = "No pending request to flush !";

            jest.spyOn(locals.nocUIMain,"handleFormValidity").mockImplementation(() => {});
            jest.spyOn(locals.nocUIMain,"clearFormValidity").mockImplementation(() => {});
            jest.spyOn(locals.nocUIMain, "block").mockReturnValue(nocUI.unblock);
            jest.spyOn(locals.nocUIMain, "loading").mockReturnValue(nocUI.unloading);

            locals.expectUItoBlockAndUnblock = function (block) {
                expect(locals.nocUI.block.mock.calls.length).toEqual(block || 1);
            };

            locals.expectUItoLoadingAndUnloading = function (loadingCount) {
                expect(locals.nocUI.loading.mock.calls.length).toEqual(loadingCount || 1);
            };

            locals.nocHttp = _nocHttpFactory_.spawn(locals.pidgeon, locals.nocUI);

            jest.spyOn(locals.nocUtil, "isMessageable").mockReturnValue(true);
            locals.$httpBackend.when('GET','/audit');

            jest.spyOn(locals.$log, "warn").mockImplementation(() => {});
            jest.spyOn(locals.$log, "info").mockImplementation(() => {});
            jest.spyOn(locals.$log, "error").mockImplementation(() => {});
            jest.spyOn(locals.$log, "debug").mockImplementation(() => {});

            //Defined globally by jasmine-promise-matchers NPM module:
            installPromiseMatchers(); //eslint-disable-line no-undef
        });

        return locals;
    };

    var constructController = function (name, opts) {
        return {controller: locals.$controller(name, opts), scope: opts.$scope};
    };

    var setDefaultController = function (opts) {
        addVar("scope", opts.scope);
        addVar("controller", opts.controller);
    };

    var setParentScope = function (scope) {
        addVar("parentScope", scope);
    };

    var initRootScope = function () {
        locals.$rootScope.pushError = jest.fn();
        locals.$rootScope.pushSuccess = jest.fn();
        locals.$rootScope.clearMessages = jest.fn();

        locals.$rootScope.tutorial = {};
        locals.$rootScope.tutorial.html = "";
        locals.$rootScope.tutorial.show = false;
        locals.$rootScope.tutorial.TUTORIAL_CLOSED_MESSAGE = "TUTORIAL_CLOSED";
    };

    magnifispec.mockValue = function(name, mock){
        locals.$provide.value(name, mock);

        return mock;
    };

    /*
     Constructs a child scope from the root
     */
    magnifispec.mockController = function (name, opts) {
        setDefaultController(constructController(name, _.assignIn({$scope: locals.$rootScope.$new()}, opts)));
    };

    magnifispec.mockConfirmController = function(name, opts, parentScopeExtensions) {
        setParentScope(locals.$rootScope.$new());

        parentScopeExtensions = parentScopeExtensions || {};
        parentScopeExtensions.modalOk = jest.fn();
        parentScopeExtensions.modalCancel = jest.fn();

        _.assignIn(locals.parentScope, parentScopeExtensions);

        initRootScope();
        setDefaultController(constructController(name, _.assignIn({$scope: locals.parentScope.$new()}, opts)));
    };

    magnifispec.mockDialogController = function(name, opts, parentScopeExtensions) {
        setParentScope(locals.$rootScope.$new());

        parentScopeExtensions = parentScopeExtensions || {};
        parentScopeExtensions.closeDialog = jest.fn();

        _.assignIn(locals.parentScope, parentScopeExtensions);

        initRootScope();
        setDefaultController(constructController(name, _.assignIn({$scope: locals.parentScope.$new()}, opts)));
    };

    /*
     Constructs a parent scope with mocked functions that should exist in the tab controller,
     Constructs the child scope from the parent scope.
     */

    magnifispec.mockTabsController = function (name, opts, parentScopeExtensions) {
        setParentScope(locals.$rootScope.$new());

        _.assignIn(locals.parentScope, parentScopeExtensions);
        initRootScope();
        setDefaultController(constructController(name, _.assignIn({$scope: locals.parentScope.$new()}, opts)));
    };

    /*
     Constructs a parent scope with mocked functions that should exist in the standalone controller,
     Constructs the child scope from the parent scope.
     */
    magnifispec.mockStandaloneController = function (name, opts) {
        setParentScope(locals.$rootScope.$new());

        initRootScope();

        setDefaultController(constructController(name, _.assignIn({$scope: locals.parentScope.$new()}, opts)));
    };

    /*
     Constructs a parent scope with mocked functions that should exist in the wizard controller,
     Constructs the child scope from the parent scope.
     */
    magnifispec.mockWizardStepController = function (name, opts, parentScopeExtensions) {
        setParentScope(locals.$rootScope.$new());

        parentScopeExtensions = parentScopeExtensions || {};
        _.assignIn(locals.parentScope, parentScopeExtensions);
        parentScopeExtensions.closeDialog = jest.fn();

        _.assignIn(locals.parentScope , jasmine.createSpyObj("parentScope", ['staticFeedback', 'feedback', 'backupStepData', 'clearAllStepData', 'getStepData', 'clearStepData', 'scrollToElementByClass','goIfNotCanceled']));

        locals.parentScope.wizardController = locals.parentScope;

        setDefaultController(constructController(name, _.assignIn({$scope: locals.parentScope.$new()}, opts)));
    };

    magnifispec.digest = function (html, scopeAttributes, selector) {
        var scope = locals.$rootScope.$new();
        _.assignIn(scope, scopeAttributes);
        var element = locals.$compile(html)(scope);
        locals.$rootScope.$digest();

        return selector ? element.find(selector) : element;
    };

    magnifispec.mockConfirm = function mockConfirm(confirm) {
        jest.spyOn(locals.nocDialog, 'confirm').mockReturnValue(confirm ? locals.$q.when(confirm) : locals.$q.reject());
    };

    //DEPRECATED, use mockConfirm instead.
    //This function is mocking up promise mechanism, it is better to use real promises instead.
    //The deprecation is enforced by eslint_plugin_noc rule: no-fake-promise.
    magnifispec.fakeConfirmNew = function(confirm){
        jest.spyOn(locals.nocDialog, "confirm").mockReturnValue({
            then:function(successCallback, errorCallback){
                if (confirm && successCallback) successCallback(confirm);
                if (!confirm && errorCallback) errorCallback();

                return {
                    finally: function (f) {
                        if (f) f();
                    },
                    catch: function (errorCallback) {
                        if (!confirm && errorCallback) errorCallback();
                    }
                };
            }
        });
    };

    magnifispec.fakeDialog = function(){
        var finish = _.noop;
        jest.spyOn(locals.nocDialog, "dialog").mockReturnValue({
            then:function(successCallback){
                finish = successCallback;
            }
        });
        return function(){
            finish.apply(this, arguments);
        };
    };

    magnifispec.initializeManifestWithPermutations = function() {
        locals.nocHttp.get = jest.fn().mockReturnValue(locals.$q.when(magnifispec.getMockedResponses().awsPermutations));
        expect(locals.ManifestMapper.initialize(locals.nocHttp, 'VSA_AWS')).toBeResolved();
    };

    magnifispec.initializeManifestWithNoPermutations = function() {
        locals.nocHttp.get = jest.fn().mockReturnValue(locals.$q.when([]));
        expect(locals.ManifestMapper.initialize(locals.nocHttp, 'VSA_AWS')).toBeRejectedWith("Cannot Create a new Cloud Volumes ONTAP, Cannot find valid mapping in manifest. You can still discover an existing working environment.");
    };

    magnifispec.getMockedResponses = function () {
        return {

            awsPermutations : [{
                "ontapVersion": "ONTAP-9.0X21.T1",
                "license": {
                    "type": "cot-explore-paygo",
                    "name": "Cloud Volumes ONTAP Explore",
                    "description": "Suitable for smaller capacity applications (up to 2TB of underlying AWS storage)",
                    "capacity_limit": "2TB",
                    "platformLicenseRequired": false,
                    "default": false,
                    "capacityLimit": {
                        "size": 2.0,
                        "unit": "TB"
                    }
                },
                "instanceType": "m4.xlarge",
                "region": {
                    "name": "EU",
                    "code": "eu-central-1",
                    "location": "Frankfurt"
                },
                "defaultInstance": true,
                "features": [],
                "upgradeableFrom": []
            },
                {
                    "ontapVersion": "ONTAP-9.0X21.T1",
                    "license": {
                        "type": "cot-explore-paygo",
                        "name": "Cloud Volumes ONTAP Explore",
                        "description": "Suitable for smaller capacity applications (up to 2TB of underlying AWS storage)",
                        "capacity_limit": "2TB",
                        "platformLicenseRequired": false,
                        "default": false,
                        "capacityLimit": {
                            "size": 2.0,
                            "unit": "TB"
                        }
                    },
                    "instanceType": "m4.xlarge",
                    "region": {
                        "name": "EU",
                        "code": "eu-west-1",
                        "location": "Ireland"
                    },
                    "defaultInstance": true,
                    "features": [],
                    "upgradeableFrom": []
                },
                {
                    "ontapVersion": "ONTAP.ENG-8.3.2.T5",
                    "license": {
                        "type": "cot-standard-paygo",
                        "name": "Cloud Volumes ONTAP Standard",
                        "description": "Flexible performance and larger capacity for a wider range of applications (up to 10TB of underlying AWS storage)",
                        "capacity_limit": "10TB",
                        "platformLicenseRequired": false,
                        "default": true,
                        "capacityLimit": {
                            "size": 10.0,
                            "unit": "TB"
                        }
                    },
                    "instanceType": "m4.2xlarge",
                    "region": {
                        "name": "Asia Pacific",
                        "code": "ap-southeast-1",
                        "location": "Singapore"
                    },
                    "defaultInstance": true,
                    "features": ["encryption"],
                    "upgradeableFrom": ["8.3"]
                },
                {
                    "ontapVersion": "ONTAP-9.0X21.T1",
                    "license": {
                        "type": "cot-standard-paygo",
                        "name": "Cloud Volumes ONTAP Standard",
                        "description": "Flexible performance and larger capacity for a wider range of applications (up to 10TB of underlying AWS storage)",
                        "capacity_limit": "10TB",
                        "platformLicenseRequired": false,
                        "default": true,
                        "capacityLimit": {
                            "size": 10.0,
                            "unit": "TB"
                        }
                    },
                    "instanceType": "m3.2xlarge",
                    "region": {
                        "name": "US West",
                        "code": "us-west-2",
                        "location": "Oregon"
                    },
                    "defaultInstance": false,
                    "features": [],
                    "upgradeableFrom": []
                },
                {
                    "ontapVersion": "ONTAP-8.4X16.T1.ha",
                    "license": {
                        "type": "cot-premium-paygo",
                        "name": "Cloud Volumes ONTAP Premium",
                        "description": "Flexible performance and expanded capacity for a wider range of applications. Supports up to 368 TB",
                        "capacity_limit": "368TB",
                        "platformLicenseRequired": false,
                        "default": false,
                        "capacityLimit": {
                            "size": 368.0,
                            "unit": "TB"
                        }
                    },
                    "instanceType": "r3.2xlarge",
                    "region": {
                        "name": "US West",
                        "code": "us-west-1",
                        "location": "N. California"
                    },
                    "defaultInstance": true,
                    "features": ["encryption"],
                    "upgradeableFrom": []
                },
                {
                    "ontapVersion": "ONTAP-8.4X16.T1.ha",
                    "license": {
                        "type": "cot-explore-paygo",
                        "name": "Cloud Volumes ONTAP Explore",
                        "description": "Suitable for smaller capacity applications (up to 2TB of underlying AWS storage)",
                        "capacity_limit": "2TB",
                        "platformLicenseRequired": false,
                        "default": true,
                        "capacityLimit": {
                            "size": 2.0,
                            "unit": "TB"
                        }
                    },
                    "instanceType": "m4.xlarge",
                    "region": {
                        "name": "US West",
                        "code": "us-west-1",
                        "location": "N. California"
                    },
                    "defaultInstance": true,
                    "features": [],
                    "upgradeableFrom": []
                },
                {
                    "ontapVersion": "ONTAP.ENG-8.3.2.T5",
                    "license": {
                        "type": "cot-premium-byol",
                        "name": "Cloud Volumes ONTAP BYOL",
                        "description": "Flexible performance and expanded capacity for a wider range of applications. Supports up to 368 TB",
                        "capacity_limit": "368TB",
                        "platformLicenseRequired": true,
                        "default": false,
                        "capacityLimit": {
                            "size": 368.0,
                            "unit": "TB"
                        }
                    },
                    "instanceType": "m4.xlarge",
                    "region": {
                        "name": "US West",
                        "code": "us-west-1",
                        "location": "N. California"
                    },
                    "defaultInstance": false,
                    "features": ['new-feature'],
                    "upgradeableFrom": ["8.3"]
                },
                {
                    "ontapVersion": "ONTAP.ENG-8.3.2.T5",
                    "license": {
                        "type": "cot-premium-byol",
                        "name": "Cloud Volumes ONTAP BYOL",
                        "description": "Flexible performance and expanded capacity for a wider range of applications. Supports up to 368 TB",
                        "capacity_limit": "368TB",
                        "platformLicenseRequired": true,
                        "default": false,
                        "capacityLimit": {
                            "size": 368.0,
                            "unit": "TB"
                        }
                    },
                    "instanceType": "m9.xlarge",
                    "region": {
                        "name": "US West",
                        "code": "us-west-1",
                        "location": "N. California"
                    },
                    "defaultInstance": false,
                    "features": [],
                    "upgradeableFrom": ["8.3"]
                },
                {
                    "ontapVersion": "ONTAP.ENG-8.3.2.T9",
                    "license": {
                        "type": "cot-premium-byol",
                        "name": "Cloud Volumes ONTAP BYOL",
                        "description": "Flexible performance and expanded capacity for a wider range of applications. Supports up to 368 TB",
                        "capacity_limit": "368TB",
                        "platformLicenseRequired": true,
                        "default": false,
                        "capacityLimit": {
                            "size": 368.0,
                            "unit": "TB"
                        }
                    },
                    "instanceType": "m9.xlarge",
                    "region": {
                        "name": "US West",
                        "code": "us-west-1",
                        "location": "N. California"
                    },
                    "defaultInstance": false,
                    "features": [],
                    "upgradeableFrom": ["8.3"]
                }
            ],

            diskSizesResponse: [
                {
                    size: {
                        size: 100,
                        unit: 'GB'
                    },
                    description: "Low performance"
                },
                {
                    size: {
                        size: 500,
                        unit: 'GB'
                    },
                    description: "Medium performance"
                },
                {
                    size: {
                        size: 1,
                        unit: 'TB'
                    },
                    description: "High performance"
                }
            ],

            aggregatesResponse: [
                {
                    "name": "aggr1",
                    "availableCapacity": {
                        "size": 17888350208,
                        "unit": "Byte"
                    },
                    "totalCapacity": {
                        "size": 18973343744,
                        "unit": "Byte"
                    },
                    "volumes": [],
                    "providerVolumes": [
                        {
                            "id": "vol-33f55330",
                            "size": {
                                "size": 1099511627776,
                                "unit": "Byte"
                            },
                            "state": "in-use",
                            "iops": 300,
                            "device": "/dev/xvdg",
                            diskType: "gp2"
                        },
                        {
                            "id": "vol-5df2545e",
                            "size": {
                                "size": 1099511627776,
                                "unit": "Byte"
                            },
                            "state": "in-use",
                            "iops": 300,
                            "device": "/dev/xvdh",
                            diskType: "gp2"
                        }
                    ],
                    "disks": [
                        {
                            "name": "NET-1.3",
                            "position": "data",
                            "ownerNode": "itayitay-01",
                            "device": "xvdh"
                        },
                        {
                            "name": "NET-1.2",
                            "position": "data",
                            "ownerNode": "itayitay-01",
                            "device": "xvdg"
                        }
                    ],
                    "state": "online",
                    "encryptionType": "ontapEncrypted"
                },
                {
                    "name": "aggr2",
                    "availableCapacity": {
                        "size": 5844435009536,
                        "unit": "Byte"
                    },
                    "totalCapacity": {
                        "size": 5844435431424,
                        "unit": "Byte"
                    },
                    "volumes": [],
                    "providerVolumes": [
                        {
                            "id": "vol-ccf254cf",
                            "size": {
                                "size": 1099511627776,
                                "unit": "Byte"
                            },
                            "state": "in-use",
                            "iops": 3000,
                            "device": "/dev/xvdi",
                            diskType: "st1"
                        },
                        {
                            "id": "vol-fbf254f8",
                            "size": {
                                "size": 1099511627776,
                                "unit": "Byte"
                            },
                            "state": "in-use",
                            "iops": 3000,
                            "device": "/dev/xvdl",
                            diskType: "st1"
                        },
                        {
                            "id": "vol-21f35522",
                            "size": {
                                "size": 1099511627776,
                                "unit": "Byte"
                            },
                            "state": "in-use",
                            "iops": 3000,
                            "device": "/dev/xvdk",
                            diskType: "st1"
                        },
                        {
                            "id": "vol-20f35523",
                            "size": {
                                "size": 1099511627776,
                                "unit": "Byte"
                            },
                            "state": "in-use",
                            "iops": 3000,
                            "device": "/dev/xvdm",
                            diskType: "st1"
                        },
                        {
                            "id": "vol-27f35524",
                            "size": {
                                "size": 1099511627776,
                                "unit": "Byte"
                            },
                            "state": "in-use",
                            "iops": 3000,
                            "device": "/dev/xvdn",
                            diskType: "st1"
                        },
                        {
                            "id": "vol-24f35527",
                            "size": {
                                "size": 1099511627776,
                                "unit": "Byte"
                            },
                            "state": "in-use",
                            "iops": 3000,
                            "device": "/dev/xvdj",
                            diskType: "st1"
                        }
                    ],
                    "disks": [
                        {
                            "name": "NET-1.4",
                            "position": "data",
                            "ownerNode": "itayitay-01",
                            "device": "xvdj"
                        },
                        {
                            "name": "NET-1.8",
                            "position": "data",
                            "ownerNode": "itayitay-01",
                            "device": "xvdn"
                        },
                        {
                            "name": "NET-1.6",
                            "position": "data",
                            "ownerNode": "itayitay-01",
                            "device": "xvdk"
                        },
                        {
                            "name": "NET-1.5",
                            "position": "data",
                            "ownerNode": "itayitay-01",
                            "device": "xvdi"
                        },
                        {
                            "name": "NET-1.9",
                            "position": "data",
                            "ownerNode": "itayitay-01",
                            "device": "xvdl"
                        },
                        {
                            "name": "NET-1.7",
                            "position": "data",
                            "ownerNode": "itayitay-01",
                            "device": "xvdm"
                        }
                    ],
                    "state": "online",
                    "encryptionType": "na"
                }
            ]
        };
    };

    magnifispec.awsEncryptionKeysObject = {
        awsEncryptionKeys: [
            {
                alias: 'aws/ebs',
                keyId: 'c1bb46f0-f6c9-4b60-b3cd-03bda6948a18',
                status: 'Enabled',
                validTo: null,
                origin: 'AWS_KMS',
                default: true,
                chosen: true,
                expiring: false,
                expired: false,
                formattedDate: 'None'
            },
            {
                alias: 'Sunday bloody sunday',
                keyId: 'y4ui6lf9-4081-4b6a-rtyg-baf579e1706e',
                status: 'Enabled',
                validTo: null,
                origin: 'EXTERNAL',
                default: false,
                expiring: false,
                expired: false,
                formattedDate: 'None'
            }
        ],
        awsEncryptionKey: {
            alias: 'aws/ebs',
            keyId: 'c1bb46f0-f6c9-4b60-b3cd-03bda6948a18',
            status: 'Enabled',
            validTo: null,
            origin: 'AWS_KMS',
            default: true,
            chosen: true,
            expiring: false,
            expired: false,
            formattedDate: 'None'
        }
    };

    //DEPRECATED.
    //This function is mocking up promise mechanism, it is better to use real promises instead.
    //The deprecation is enforced by eslint_plugin_noc rule: no-fake-promise.
    magnifispec.mockDeferredPromise = function(success, object, methodName, successResponse){
        var finallyFunc = function (finallyCallback) {
            if (finallyCallback) {
                finallyCallback();
            }
        };


        jest.spyOn(object, methodName).mockReturnValue({
                then: function (successCallback) {
                    if (success && successCallback) successCallback(successResponse);
                    return {
                        catch: function (errorCallback) {
                            if (!success && errorCallback) errorCallback(locals.errorResponse);
                            return {
                                "finally": finallyFunc
                            };
                        }
                    };
                },
                finally: finallyFunc
            }
        );
    };

    //Parameter 'forceResolve' is for cases we want to resolve null or other falsy value.
    magnifispec.mockPromise = function (resolvedValue, forceReslove) {
        return function() {
            if (resolvedValue || forceReslove) {
                return locals.$q.when(resolvedValue);
            } else {
                return locals.$q.reject(locals.errorResponse);
            }
        };
    };

    magnifispec.processPromise = function(){
        locals.$rootScope.$apply();
    };

    magnifispec.auditSummaries = [
        {
            "actionName": "Change Keys",
            "status": "Success",
            "userName": "admin admin",
            "tenantName": null,
            "workingEnvironmentName": null
        },
        {
            "actionName": "Update Cloud Ontap Metadata",
            "status": "Failed",
            "userName": "System",
            "tenantName": null,
            "workingEnvironmentName": null
        },
        {
            "actionName": "Delete Vsa Working Environment",
            "status": "Success",
            "userName": "admin admin",
            "tenantName": "Tenant 1",
            "workingEnvironmentName": "ss",
            "containsFailedRecords": true
        },
        {
            "actionName": "Login",
            "status": "Success",
            "userName": "admin admin",
            "tenantName": null,
            "workingEnvironmentName": null
        },
        {
            "actionName": "Change Current User Azure Credentials",
            "status": "Success",
            "userName": "admin admin",
            "tenantName": null,
            "workingEnvironmentName": null
        }
    ];
})();
window.magnifispec = magnifispec;
