describe.skip('AwsTagsValidation', function () {
    'use strict';

    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });
    var scope, element;
    beforeEach(function () {
        scope = j.$rootScope.$new();
        scope.model = [{tagKey: ''}, {tagKey: ''}];
        element = j.$compile('<form name=\'aws\'>' +
            '<div><input type=\'text\' ng-model=\'model[0].tagKey\' noc-tags-validation=\'{tags: model, provider: "AWS"}\'/></div>' +
            '<div><input type=\'text\' ng-model=\'model[1].tagKey\' noc-tags-validation=\'{tags: model, provider: "AWS"}\'/></div>' +
            '</form>')(scope);
        scope.$digest();
    });

    it('should set validity to true if the first input is empty', function () {
        scope.model[0].tagKey = '';
        scope.model[1].tagKey = 'bla';
        scope.$digest();

        expect(element.hasClass('ng-valid')).toEqual(true);
        expect(element.children().children().hasClass('ng-valid-noc-tags-validation')).toEqual(true);
    });

    it('should set validity to true if the second input is empty', function () {
        scope.model[1].tagKey = '';
        scope.model[0].tagKey = 'bla';
        scope.$digest();

        expect(element.hasClass('ng-valid')).toEqual(true);
        expect(element.children().children().hasClass('ng-valid-noc-tags-validation')).toEqual(true);
    });

    it('should set validity of noc-tags-validation to false if inputs are the same', function () {
        scope.model[1].tagKey = 'bla';
        scope.model[0].tagKey = 'bla';
        scope.$digest();

        expect(element.hasClass('ng-invalid')).toEqual(true);
        expect(element.hasClass('ng-invalid-noc-tags-validation')).toEqual(true);
    });

    it('should set validity of noc-tags-validation to true if inputs are then different', function () {
        scope.model[1].tagKey = 'bla';
        scope.model[0].tagKey = 'bla';
        scope.$digest();

        scope.model[1].tagKey = 'bla2';
        scope.$digest();

        expect(element.hasClass('ng-invalid')).toEqual(false);
        expect(element.hasClass('ng-valid')).toEqual(true);
        expect(element.hasClass('ng-invalid-noc-tags-validation')).toEqual(false);
        expect(element.hasClass('ng-valid-noc-tags-validation')).toEqual(true);

        expect(element.children().children().hasClass('ng-valid-noc-tags-validation')).toEqual(true);
    });
});