describe.skip("noc-keypress", function () {
    "use strict";

    function latestUIKeypressValue() {
        return keypressHelperMock.mock.calls[0][3].uiKeypress;
    }

    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    var scope, element, keypressHelperMock;

    beforeEach(function () {
        keypressHelperMock = jest.fn();
        magnifispec.mockValue('keypressHelper',keypressHelperMock);
        scope = j.$rootScope.$new();
    });

    function init(nocKeypressParams, additionalAtttributes){
        additionalAtttributes = additionalAtttributes || '';
        var elemet = '<button noc-keypress="' + nocKeypressParams + '" '+additionalAtttributes+'></button>';
        element = j.$compile(elemet)(scope);
        scope.$digest();
    }

    describe("should properly handle", function () {
        function assertEventHandled(eventName) {
            var elemet = '<button noc-'+eventName+'="{esc:\'alert()\'}"></button>';
            element = j.$compile(elemet)(scope);
            scope.$digest();
            var args = keypressHelperMock.mock.calls[0];
            expect(args[0]).toEqual(eventName);
            expect(args[1]).toEqual(scope);
            expect(args[2]).toEqual(element);
        }

        it("noc-keypress", function () {
            assertEventHandled('keypress');
        });
        it("noc-keydown", function () {
            assertEventHandled('keydown');
        });
        it("noc-keyup", function () {
            assertEventHandled('keyup');
        });
    });

    it("should pass object like params as is to ui-keypress", function () {
        init("{24:'1+1', esc:'alert()'}");
        expect(latestUIKeypressValue()).toEqual("{24:'1+1', esc:'alert()'}");
    });
    it("should wrap key as object with ng-click as value", function () {
        init("esc","ng-click=\"alert()\"");
        expect(latestUIKeypressValue()).toEqual("{ esc: 'alert()'}");
    });
    it("should wrap key as object with ng-click as value - with single quote", function () {
        init("esc","ng-click=\"alert('aa')\"");
        expect(latestUIKeypressValue()).toEqual("{ esc: 'alert(\\'aa\\')'}");
    });
    it("should not wrap key as object if there's no ng-click", function () {
        init("esc");
        expect(latestUIKeypressValue()).toEqual("esc");
    });
});