describe.skip("", function () {
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    var scope, element;
    beforeEach(function () {
        scope = j.$rootScope.$new();
        scope.changePassword = {newPassword:"1234", retypePassword:"1234"};
        element = j.$compile("<form name='changePasswordForm' id='password_form'>"+
                                    "<div><input type='password' ng-model='changePassword.newPassword'/></div>"+
                                    "<div><input type='password' name='retype_password' ng-model='changePassword.retypePassword' noc-password-verify='changePassword.newPassword'/></div>"+
                                "</form>")(scope);
        scope.$digest();
    });

    it("should add 5 watchers on creation", function () {
        expect(scope.$$watchers.length).toEqual(5); //one for the passwordVerify error, and 2 for the ng-model //additional one for each input due to to validation framework
    });

    it("should set validity of passwordVerify to true if newPassword is empty", function () {
        scope.changePassword.newPassword = "";
        scope.$digest();

        expect(element.hasClass("ng-valid")).toEqual(true);
        expect(element.children().children().hasClass("ng-valid-password-verify")).toEqual(true);
    });

    it("should set validity of passwordVerify to true if newPassword is undefined", function () {
        delete scope.changePassword.newPassword;
        scope.$digest();

        expect(element.hasClass("ng-valid")).toEqual(true);
        expect(element.children().children().hasClass("ng-valid-password-verify")).toEqual(true);
    });

    it("should set validity of passwordVerify to true if retypePassword is empty", function () {
        scope.changePassword.retypePassword = "";
        scope.$digest();

        expect(element.hasClass("ng-valid")).toEqual(true);
    });

    it("should set validity of passwordVerify to true if retypePassword is undefined", function () {
        delete scope.changePassword.retypePassword;
        scope.$digest();

        expect(element.hasClass("ng-valid")).toEqual(true);
        expect(element.children().children().hasClass("ng-valid-password-verify")).toEqual(true);
    });

    it("should set validity of passwordVerify to false if newPassword is different than retype password", function () {
        scope.changePassword.newPassword = "1111";
        scope.changePassword.retypePassword = "2222";
        scope.$digest();

        expect(element.hasClass("ng-invalid")).toEqual(true);
        expect(element.hasClass("ng-invalid-password-verify")).toEqual(true);
    });

    it("should set validity of passwordVerify to true if newPassword is the same as retype password", function () {
        scope.changePassword.newPassword = "1111";
        scope.changePassword.retypePassword = "1111";
        scope.$digest();

        expect(element.hasClass("ng-valid")).toEqual(true);
        expect(element.children().children().hasClass("ng-valid-password-verify")).toEqual(true);
    });





});