describe.skip("Popover Directive", function () {
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });

    var scope, parent, popoverClicker;
    beforeEach(function () {
        $("body").empty();
        $("body").append("<div class='popover-helper'></div>");
        scope = j.$rootScope.$new();
        scope.nocall = jest.fn();
        parent = j.$compile("<div ng-click='nocall()'><div noc-popover='\"test.html\"'></div></div>")(scope);
        popoverClicker = parent.children();
        j.$httpBackend.expectGET("/occm/api/test.html").respond("<div>test</div>");
    });

    it("on click it should prevent event propagation", function () {
        popoverClicker.click();
        expect(scope.nocall).not.toHaveBeenCalled();
    });

    it("should add the noc-popover to the popover helper", function(){
        popoverClicker.click();
        j.$httpBackend.flush();
        j.$timeout.flush();
        expect($("body").find(".popover-helper .noc-popover").length).toEqual(1);
    });

    it("should not append the popover to the parent if no flags are present", function () {
        popoverClicker.click();
        expect(parent.find('.noc-popover').length).toEqual(0);
        j.$httpBackend.flush();
        j.$timeout.flush();
        expect(parent.find('.noc-popover').length).toEqual(0);
        expect($("body").find(".popover-helper .noc-popover").length).toEqual(1);
    });

    describe("on click listener added to body", function () {
        var body;
        beforeEach(function () {
            body = $("body");
        });
        var clickAndFlush = function(){
            popoverClicker.click();
            j.$httpBackend.flush();
            j.$timeout.flush();
        };
        it("should not do anything if the click was on a popover", function () {
            body.append("<div class='popover'></div>");
            clickAndFlush();
            body.find(".popover").click();
            expect($("body").find(".popover-helper .noc-popover").length).toEqual(1);
        });

        it("should delete the popover if the click was not on a popover", function () {
            clickAndFlush();
            body.click();
            j.$timeout.flush();
            expect($("body").find(".popover-helper .noc-popover").length).toEqual(0);
        });
    });

});