describe.skip("noc radio directive", function () {
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    var scope;
    var tElement1, tElement2 , tElement3, tElementDisabled;
    var element1, element2, element3, elementDisabled;
    var parent;

    beforeEach(function () {
        scope = j.$rootScope.$new();
        scope.model = '1';
        scope.text1 = "someText1";
        scope.text2 = "someText2";
        scope.text3 = "someText3";
        tElement1 = $("<input type='radio' name='optionsRadios' noc-radio ng-model='model' value='1' text='{{text1}}'/>");
        tElement2 = $("<input type='radio' name='optionsRadios' noc-radio ng-model='model' value='2' text='{{text2}}' />");
        tElement3 = $("<input type='radio' name='optionsRadios' noc-radio ng-model='model' value='3' text='{{text3}}' />");
        tElementDisabled = $("<input type='radio' name='optionsRadios' noc-radio ng-model='model' value='4' disabled='true'/>");
        $('body').append(tElement1).append(tElement2).append(tElement3).append(tElementDisabled);
    });

    it("should construct the radio wrapper properly ", function () {
        element1 = j.$compile(tElement1)(scope);
        parent = element1.parent();
        scope.$apply(function() {
           scope.model = '1';
        });
        expect(parent.hasClass("radio-label-selected")).toEqual(true);
        expect(parent.children().is("input")).toEqual(true);
        expect(parent.text().indexOf("someText1")).not.toEqual(-1);
    });

    it("should update the classes when model changes", function () {
        element1 = j.$compile(tElement1)(scope);
        element2 = j.$compile(tElement2)(scope);
        element3 = j.$compile(tElement3)(scope);
        scope.$apply(function () {
            scope.model = '2';
        });
        expect(element1.parent().hasClass("radio-label-selected")).toEqual(false);
        expect(element2.parent().hasClass("radio-label-selected")).toEqual(true);
        expect(element3.parent().hasClass("radio-label-selected")).toEqual(false);
        scope.$apply(function () {
            scope.model = '3';
        });
        expect(element1.parent().hasClass("radio-label-selected")).toEqual(false);
        expect(element2.parent().hasClass("radio-label-selected")).toEqual(false);
        expect(element3.parent().hasClass("radio-label-selected")).toEqual(true);

    });

    it("should update the class when disabled", function () {
        elementDisabled = j.$compile(tElementDisabled)(scope);
        scope.$apply(function () {
            scope.model = '1';
        });
        expect(elementDisabled.parent().hasClass("radio-label-disabled")).toEqual(true);
    });

    it("should update the class when focused", function () {
        element1 = j.$compile(tElement1)(scope);
        element1.triggerHandler('focus');
        scope.$apply(function () {
            scope.model = '1';
        });
        expect(element1.parent().hasClass("radio-label-focused")).toEqual(true);
    });

    it("should be able to create an input radio without text", function () {
        delete scope.text1;
        element1 = j.$compile(tElement1)(scope);
        parent = element1.parent();
        expect(parent.text()).toEqual('');
    });
});