describe.skip('Upload NLF component', function () {
    'use strict';

    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    let scope, element, ctrlUploadNlf;
    beforeEach(function () {
        j.$provide.factory('nocIconDirective', () => {
            return {};
        });
        scope = j.$rootScope.$new();
        scope.licenseFileName = {};
        scope.providedLicense = '';
        scope.providedLicenseNode1 = '';
        scope.providedLicenseNode2 = '';
        scope.expirationDate = {};
        scope.workingEnvironmentType = '';
        scope.nocHttp = j.nocHttp;
        let parent = angular.element(`<ng-form>
            <upload-nlf-component noc-http="nocHttp"
                                  license-file-name="licenseFileName"
                                  expiration-date="expirationDate"
                                  working-environment-type="workingEnvironmentType"
                                  upload-problem="uploadProblem"
                                  provided-license-node1="providedLicenseNode1"
                                  provided-license-node2="providedLicenseNode2"
                                  provided-license="providedLicense"></upload-nlf-component></ng-form>`);
        parent = j.$compile(parent)(scope);
        scope.$digest();
        element = parent.children().first();
        ctrlUploadNlf = element.controller('uploadNlfComponent');
    });

    describe('uploading a license file', () => {
        it('should display the correct data when successfully uploaded for single node', () => {
            ctrlUploadNlf.workingEnvironmentType = 'VSA';
            const hiddenInput = {
                'id': '#hiddenInputNode1',
                'files': [{'name': 'nlf.html'}, {'name': '456'}]
            };
            jest.spyOn(ctrlUploadNlf, 'upload').mockReturnValue(j.$q.when({'serialNumber': '111', 'license': 'ABC'}));

            ctrlUploadNlf.uploadLicenseFile(hiddenInput);
            magnifispec.processPromise();

            expect(ctrlUploadNlf.providedLicense).toEqual('ABC');
            expect(ctrlUploadNlf.licenseFileName[1]).toEqual('nlf.html');
            expect(ctrlUploadNlf.licenseSerialNumber[1]).toEqual('111');
        });

        it('should display the correct data when successfully uploaded for HA', () => {
            ctrlUploadNlf.workingEnvironmentType = 'HA';
            const hiddenInput = {
                'id': '#hiddenInputNode2',
                'files': [{'name': 'nlf-ha.html'}, {'name': '456'}]
            };
            ctrlUploadNlf.licenseFileName = {};
            jest.spyOn(ctrlUploadNlf, 'upload').mockReturnValue(j.$q.when({
                'serialNumber': '90120140000000000023',
                'license': 'ABC'
            }));

            ctrlUploadNlf.uploadLicenseFile(hiddenInput);
            magnifispec.processPromise();

            expect(ctrlUploadNlf.licenseFileName[2]).toEqual('nlf-ha.html');
            expect(ctrlUploadNlf['providedLicenseNode2']).toEqual('ABC');
            expect(ctrlUploadNlf.licenseSerialNumber[2]).toEqual('90120140000000000023');
        });

        it('should display a proper error if upload failed', () => {
            ctrlUploadNlf.workingEnvironmentType = 'VSA';
            const hiddenInput = {
                'id': '#hiddenInputNode1',
                'files': [{'name': 'nlf-pagum.html'}, {'name': '456'}]
            };
            ctrlUploadNlf.licenseFileName = {};
            jest.spyOn(ctrlUploadNlf, 'upload').mockReturnValue(j.$q.reject(j.errorResponse));

            ctrlUploadNlf.uploadLicenseFile(hiddenInput);
            magnifispec.processPromise();

            expect(ctrlUploadNlf.licenseFileName[1]).toEqual('nlf-pagum.html');
            expect(ctrlUploadNlf.uploadProblem[1]).toEqual(true);
            expect(ctrlUploadNlf.errorMessage[1]).toEqual('The file format is invalid');
        });
    });
});
