describe('action required can show if off', () => {
    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });

    it('should return the same array if status is on', () => {
        const result = j.$filter('actionRequiredCanShowIfOff')([1, 2, 3], 'on');
        expect(result).toEqual([1, 2, 3]);
    });

    it('should filter the array if status is not on', () => {
        const result = j.$filter('actionRequiredCanShowIfOff')([
            {actionType: 'something that should be removed'},
            {actionType: 'licenseGracePeriod'},
            {actionType: 'licenseExpirationWarning'},
            {actionType: 'licenseWasSuspended'}
        ]);
        expect(result).toEqual([{actionType: 'licenseGracePeriod'}, {actionType: 'licenseExpirationWarning'}, {actionType: 'licenseWasSuspended'}]);
    });
});
