describe("dateAndTimeUtc", function () {
    var theFilter;
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    beforeEach(function () {
        theFilter = j.$filter('dateAndTimeUtc');
    });

    it('should format date and time like a boss in UTC timezone', function () {
        expect(theFilter(1424772733221)).toEqual('Feb 24, 2015 10:12:13 am UTC');
    });
});

describe("Date and Time filter", function () {
    var theFilter;
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    beforeEach(function () {
        theFilter = j.$filter('dateAndTime');
    });

    it('should format date and time like a boss', function () {
        expect(theFilter(1424772733221)).toEqual('Feb 24, 2015 12:12:13 pm');
    });

    it('should show leading zeros like a boss', function () {
        expect(theFilter(1424747043000)).toEqual('Feb 24, 2015 05:04:03 am');
    });

    it('should display am:pm correctly', function () {
        expect(theFilter(1424790975000)).toEqual('Feb 24, 2015 05:16:15 pm');
        expect(theFilter(1424747775000)).toEqual('Feb 24, 2015 05:16:15 am');
        expect(theFilter(1424772000000)).toEqual('Feb 24, 2015 12:00:00 pm');
        expect(theFilter(1424728800000)).toEqual('Feb 24, 2015 12:00:00 am');
    });

    it('no time should resolve to empty string',function(){
        expect(theFilter()).toEqual('');
        expect(theFilter(null)).toEqual('');
    });
});

describe("dateAndTimeOrNone filter", function () {
    var theFilter;
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    beforeEach(function () {
        theFilter = j.$filter('dateAndTimeOrNone');
    });

    it('should format date like a date and time filter', function () {
        expect(theFilter(1424772733221)).toEqual(j.$filter('dateAndTime')(1424772733221));
    });
    it('should return "None" for not a date', function () {
        expect(theFilter(null)).toEqual('None');
        expect(theFilter(undefined)).toEqual('None');
        //This test throws deprecation warning to the console.
        //Uncomment it after upgrading moment to v>3.0 and angular-moment to a version that supports moment 3.0.
        //expect(theFilter('not a date')).toEqual('None');
    });
});

describe("Full Date filter", function () {
    var theFilter;
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    beforeEach(function () {
        theFilter = j.$filter('fullDate');
    });

    it('should format date like a boss', function () {
        expect(theFilter(1424772733221)).toEqual('February 24, 2015');
    });
});