describe('propsFilter', () => {
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    let theFilter;

    /*eslint-disable no-multi-spaces*/
    const data = [
        {name: 'Adam',      age: 10},
        {name: 'Amalie',    age: 12},
        {name: 'Samantha',  age: 31},
        {name: 'Esperanza', age: 16},
        {name: 'Natasha',   age: 54},
        {name: 'Nicole',    age: 43},
        {name: 'Adrian',    age: 21}
    ];

    beforeEach(() => {
        theFilter = j.$filter('props');
    });

    it('should return original data if it is not array', () => {
        expect(theFilter('not array data', ['some', 'props'], 'searchText')).toEqual('not array data');
    });

    it('should filter by provided properties', () => {
        expect(theFilter(data, ['name', 'age'], 'Adam')).toEqual([{name: 'Adam', age: 10}]);
        expect(theFilter(data, ['name', 'age'], '10')).toEqual([{name: 'Adam', age: 10}]);
        expect(theFilter(data, ['name', 'age'], 'an')).toEqual([
            {name: 'Samantha',  age: 31},
            {name: 'Esperanza', age: 16},
            {name: 'Adrian',    age: 21}
        ]);
        expect(theFilter(data, ['name', 'age'], 'nothing')).toEqual([]);
    });

    it('should work for number fields', () => {
        expect(theFilter(data, ['name', 'age'], '2')).toEqual([
            {name: 'Amalie', age: 12},
            {name: 'Adrian', age: 21}
        ]);
    });

    it('should search case-insensitive', () => {
        expect(theFilter(data, ['name', 'age'], 'aDaM')).toEqual([{name: 'Adam', age: 10}]);
    });

    it('should ignore props that does not exist', () => {
        expect(theFilter(data, ['name', 'notExist'], 'Adam')).toEqual([{name: 'Adam', age: 10}]);
        expect(theFilter(data, ['name', 'notExist'], 'nothing')).toEqual([]);
    });
    /*eslint-enable no-multi-spaces*/
});
