describe('TieringMetadataResource', () => {
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    let TieringMetadataResource;

    beforeEach(inject((_TieringMetadataResource_) => {
        TieringMetadataResource = _TieringMetadataResource_;
    }));

    describe('initEbsDiskTypesResponse', () => {
        const awsResponse = [
            {
                description: '',
                size: {
                    size: 100,
                    unit: 'GB'
                },
                supportedVolumeTypes: [
                    'standard',
                    'io1',
                    'gp2'
                ],
                supportedOccmLicenses: [
                    'Explore (hourly)',
                    'Standard (hourly)',
                    'Standard (BYOL)',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP BYOL'
                ],
                isDefault: false
            },
            {
                description: '',
                size: {
                    size: 500,
                    unit: 'GB'
                },
                supportedVolumeTypes: [
                    'standard',
                    'io1',
                    'gp2',
                    'st1'
                ],
                supportedOccmLicenses: [
                    'Explore (hourly)',
                    'Standard (hourly)',
                    'Standard (BYOL)',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP BYOL'
                ],
                isDefault: false
            },
            {
                description: '',
                size: {
                    size: 1,
                    unit: 'TB'
                },
                supportedVolumeTypes: [
                    'standard',
                    'io1',
                    'gp2',
                    'st1'
                ],
                supportedOccmLicenses: [
                    'Explore (hourly)',
                    'Standard (hourly)',
                    'Standard (BYOL)',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP BYOL'
                ],
                isDefault: true
            },
            {
                description: '',
                size: {
                    size: 2,
                    unit: 'TB'
                },
                supportedVolumeTypes: [
                    'io1',
                    'gp2',
                    'st1',
                    'sc1'
                ],
                supportedOccmLicenses: [
                    'Explore (hourly)',
                    'Standard (hourly)',
                    'Standard (BYOL)',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Explore',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP BYOL'
                ],
                isDefault: false
            },
            {
                description: '',
                size: {
                    size: 4,
                    unit: 'TB'
                },
                supportedVolumeTypes: [
                    'io1',
                    'gp2',
                    'st1',
                    'sc1'
                ],
                supportedOccmLicenses: [
                    'Standard (hourly)',
                    'Standard (BYOL)',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP BYOL'
                ],
                isDefault: false
            },
            {
                description: '',
                size: {
                    size: 8,
                    unit: 'TB'
                },
                supportedVolumeTypes: [
                    'io1',
                    'gp2',
                    'st1',
                    'sc1'
                ],
                supportedOccmLicenses: [
                    'Standard (hourly)',
                    'Standard (BYOL)',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP Premium',
                    'Cloud Volumes ONTAP BYOL',
                    'Cloud Volumes ONTAP Standard',
                    'Cloud Volumes ONTAP BYOL'
                ],
                isDefault: false
            }
        ];
        const supportedCapacityTiersObject = {
            s3TiersDisableReasons: ['reason1', 'reason2'],
            supportedCapacityTiersPerVolumeType: [
                {availableTieringPolicies: [], supportedCapacityTiers: [], volumeType: 'standard'},
                {availableTieringPolicies: [], supportedCapacityTiers: [], volumeType: 'io1'},
                {availableTieringPolicies: ['none', 'snapshot_only', 'auto'], supportedCapacityTiers: ['S3'], volumeType: 'gp2'},
                {availableTieringPolicies: ['none', 'snapshot_only', 'auto'], supportedCapacityTiers: ['S3'], volumeType: 'st1'},
                {availableTieringPolicies: [], supportedCapacityTiers: [], volumeType: 'sc1'}
            ]
        };

        it('should return only sizes that supported in given license', () => {
            const expectedResponse = {
                gp2: jasmine.objectContaining({
                    name: 'gp2',
                    supportedCapacityTiers: ['S3'],
                    supportedSizes: [
                        {size: 100, unit: 'GB', _identifier: '100 GB'},
                        {size: 500, unit: 'GB', _identifier: '500 GB'},
                        {size: 1, unit: 'TB', _identifier: '1 TB'},
                        {size: 2, unit: 'TB', _identifier: '2 TB'}
                    ]
                }),
                standard: jasmine.objectContaining({
                    name: 'standard',
                    supportedSizes: [
                        {size: 100, unit: 'GB', _identifier: '100 GB'},
                        {size: 500, unit: 'GB', _identifier: '500 GB'},
                        {size: 1, unit: 'TB', _identifier: '1 TB'}
                    ]
                }),
                st1: jasmine.objectContaining({
                    name: 'st1',
                    supportedCapacityTiers: ['S3'],
                    supportedSizes: [
                        {size: 500, unit: 'GB', _identifier: '500 GB'},
                        {size: 1, unit: 'TB', _identifier: '1 TB'},
                        {size: 2, unit: 'TB', _identifier: '2 TB'}
                    ]
                }),
                sc1: jasmine.objectContaining({
                    name: 'sc1',
                    supportedSizes: [
                        {size: 2, unit: 'TB', _identifier: '2 TB'}
                    ]
                }),
                io1: jasmine.objectContaining({
                    name: 'io1',
                    supportedSizes: [
                        {size: 100, unit: 'GB', _identifier: '100 GB'},
                        {size: 500, unit: 'GB', _identifier: '500 GB'},
                        {size: 1, unit: 'TB', _identifier: '1 TB'},
                        {size: 2, unit: 'TB', _identifier: '2 TB'}
                    ]
                })
            };
            expect(TieringMetadataResource.initEbsDiskTypesResponse(awsResponse, 'Cloud Volumes ONTAP Explore', false, supportedCapacityTiersObject)).toEqual(expectedResponse);
        });

        it('should return only disks that supports ha for ha', () => {
            expect(TieringMetadataResource.initEbsDiskTypesResponse(awsResponse, 'Cloud Volumes ONTAP Standard', true, supportedCapacityTiersObject).sc1).not.toBeDefined();
        });

        it('should add disabled message to S3 tiers if applicable', () => {
            const supportedCapacityTiersObject = {
                supportedCapacityTiersPerVolumeType: [
                    {availableTieringPolicies: [], supportedCapacityTiers: [], volumeType: 'standard', disabledMessage: 'reason'},
                    {availableTieringPolicies: ['none', 'snapshot_only', 'auto'], supportedCapacityTiers: ['S3'], volumeType: 'io1', disabledMessage: 'reason'},
                    {availableTieringPolicies: ['none', 'snapshot_only', 'auto'], supportedCapacityTiers: ['S3'], volumeType: 'gp2', disabledMessage: 'reason'},
                    {availableTieringPolicies: ['none', 'snapshot_only', 'auto'], supportedCapacityTiers: ['S3'], volumeType: 'st1', disabledMessage: 'reason'},
                    {availableTieringPolicies: [], supportedCapacityTiers: [], volumeType: 'sc1', disabledMessage: 'reason'}
                ]
            };

            const initializedResponse = TieringMetadataResource.initEbsDiskTypesResponse(awsResponse, 'Cloud Volumes ONTAP Standard', false, supportedCapacityTiersObject);

            _.forEach(initializedResponse, (type) => {
                expect(type.disabledMessage).toEqual('reason');
            });
        });

        it('should not add a message if no disable reasons exists', () => {
            const supportedCapacityTiersObject = {
                s3TiersDisableReasons: [],
                supportedCapacityTiersPerVolumeType: [
                    {availableTieringPolicies: [], supportedCapacityTiers: [], volumeType: 'standard'},
                    {availableTieringPolicies: [], supportedCapacityTiers: [], volumeType: 'io1'},
                    {availableTieringPolicies: ['none', 'snapshot_only', 'auto'], supportedCapacityTiers: ['S3'], volumeType: 'gp2'},
                    {availableTieringPolicies: ['none', 'snapshot_only', 'auto'], supportedCapacityTiers: ['S3'], volumeType: 'st1'},
                    {availableTieringPolicies: [], supportedCapacityTiers: [], volumeType: 'sc1'}
                ]
            };

            const initializedResponse = TieringMetadataResource.initEbsDiskTypesResponse(awsResponse, 'Cloud Volumes ONTAP Standard', false, supportedCapacityTiersObject);

            _.forEach(initializedResponse, (type) => {
                expect(type.disabledMessage).toEqual(undefined);
            });
        });
    });

    describe('initAzureDiskTypesResponse', () => {
        const azureResponse = [
            {
                'diskType': 'Premium',
                'availabilityTypes': [
                    'Premium_LRS'
                ],
                'sizes': [
                    {
                        size: {
                            size: 500,
                            unit: 'GB'
                        },
                        description: '',
                        supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                        isDefault: false
                    },
                    {
                        size: {
                            size: 1,
                            unit: 'TB'
                        },
                        supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                        description: '',
                        isDefault: true
                    }
                ]
            },
            {
                'diskType': 'StandardSSD',
                'availabilityTypes': [
                    'StandardSSD_LRS'
                ],
                'sizes': [
                    {
                        size: {
                            size: 100,
                            unit: 'GB'
                        },
                        supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                        description: '',
                        isDefault: false
                    },
                    {
                        size: {
                            size: 500,
                            unit: 'GB'
                        },
                        supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                        description: '',
                        isDefault: false
                    },
                    {
                        size: {
                            size: 1,
                            unit: 'TB'
                        },
                        supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                        description: '',
                        isDefault: true
                    }
                ]
            },
            {
                'diskType': 'Standard',
                'availabilityTypes': [
                    'Standard_LRS'
                ],
                'sizes': [
                    {
                        size: {
                            size: 100,
                            unit: 'GB'
                        },
                        supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                        description: '',
                        isDefault: false
                    },
                    {
                        size: {
                            size: 500,
                            unit: 'GB'
                        },
                        supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                        description: '',
                        isDefault: false
                    },
                    {
                        size: {
                            size: 1,
                            unit: 'TB'
                        },
                        supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                        description: '',
                        isDefault: true
                    }
                ]
            }

        ];

        it('should return map with appropriate structure', () => {
            const expectedResponse = {
                'Premium_LRS': {
                    name: 'Premium_LRS',
                    shortName: 'Prm',
                    diskName: 'Premium_LRS',
                    display: 'Premium SSD',
                    description: 'Higher performance at a higher cost.',
                    default: true,
                    supportedCapacityTiers: ['Blob'],
                    supportedSizes: [
                        {
                            size: {size: 500, unit: 'GB'},
                            _identifier: '500 GB',
                            description: '',
                            supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                            isDefault: false
                        },
                        {
                            size: {size: 1, unit: 'TB'},
                            _identifier: '1 TB',
                            description: '',
                            supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                            isDefault: true
                        }
                    ]
                },
                "StandardSSD_LRS": {
                    "description": "For production workloads when you need predictable IOPS performance with lower latency than HDD.",
                    "diskName": "StandardSSD_LRS",
                    "display": "Standard SSD",
                    "name": "StandardSSD_LRS",
                    "shortName": "Ssd",
                    "supportedCapacityTiers": [
                        "Blob"
                    ],
                    "supportedSizes": [
                        {
                            "_identifier": "100 GB",
                            "description": "",
                            "isDefault": false,
                            "size": {
                                "size": 100,
                                "unit": "GB"
                            },
                            "supportedOccmLicenses": [
                                "Cloud Volumes ONTAP Standard"
                            ]
                        },
                        {
                            "_identifier": "500 GB",
                            "description": "",
                            "isDefault": false,
                            "size": {
                                "size": 500,
                                "unit": "GB"
                            },
                            "supportedOccmLicenses": [
                                "Cloud Volumes ONTAP Standard"
                            ]
                        },
                        {
                            "_identifier": "1 TB",
                            "description": "",
                            "isDefault": true,
                            "size": {
                                "size": 1,
                                "unit": "TB"
                            },
                            "supportedOccmLicenses": [
                                "Cloud Volumes ONTAP Standard"
                            ]
                        }
                    ]
                },
                'Standard_LRS': {
                    name: 'Standard_LRS',
                    shortName: 'Hdd',
                    diskName: 'Standard_LRS',
                    display: 'Standard HDD',
                    description: 'Lower cost and performance. Performance may be significantly lower for some workloads.',
                    supportedCapacityTiers: ['Blob'],
                    supportedSizes: [
                        {
                            size: {size: 100, unit: 'GB'},
                            _identifier: '100 GB',
                            description: '',
                            supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                            isDefault: false
                        },
                        {
                            size: {size: 500, unit: 'GB'},
                            _identifier: '500 GB',
                            description: '',
                            supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                            isDefault: false
                        },
                        {
                            size: {size: 1, unit: 'TB'},
                            _identifier: '1 TB',
                            description: '',
                            supportedOccmLicenses: ['Cloud Volumes ONTAP Standard'],
                            isDefault: true
                        }
                    ]
                }
            };
            expect(TieringMetadataResource.initAzureDiskTypesResponse(azureResponse, 'Cloud Volumes ONTAP Standard')).toEqual(expectedResponse);
        });
    });

    describe('getSupportedCapacityTiers', () => {
        it('should resolve upon success with correct structure', () => {
            jest.spyOn(j.nocHttp, 'get').mockReturnValue(j.$q.when({
                supportedCapacityTiersPerVolumeType: [
                    {volumeType: 'standard', supportedCapacityTiers: []},
                    {volumeType: 'io1', supportedCapacityTiers: []},
                    {volumeType: 'gp2', supportedCapacityTiers: ['S3']},
                    {volumeType: 'st1', supportedCapacityTiers: ['S3']},
                    {volumeType: 'sc1', supportedCapacityTiers: []}
                ],
                s3TiersDisableReasons: ['reason1', 'reason2']
            }));

            expect(TieringMetadataResource.getSupportedCapacityTiers(j.nocHttp, '/vsa/', 'us-west-1', 'ONTAP-version-num', 'NONE', 'cot-standard-paygo', 'x4.large', undefined, 'cloudProviderAccountId'))
                .toBeResolvedWith({
                    supportedCapacityTiersPerVolumeType: [
                        {volumeType: 'standard', supportedCapacityTiers: []},
                        {volumeType: 'io1', supportedCapacityTiers: []},
                        {volumeType: 'gp2', supportedCapacityTiers: ['S3']},
                        {volumeType: 'st1', supportedCapacityTiers: ['S3']},
                        {volumeType: 'sc1', supportedCapacityTiers: []}],
                    s3TiersDisableReasons: ['reason1', 'reason2']
                });
        });

        it('should reject upon error', () => {
            jest.spyOn(j.nocHttp, 'get').mockReturnValue(j.$q.reject(j.errorResponse));

            expect(TieringMetadataResource.getSupportedCapacityTiers(j.nocHttp, '/vsa/', 'us-west-1', 'ONTAP-version-num', 'NONE', 'cot-standard-paygo', 'x4.large', undefined, 'cloudProviderAccountId'))
                .toBeRejectedWith(j.errorResponse);
        });

        afterEach(() => {
            expect(j.nocHttp.get).toHaveBeenCalledWith({
                url: '/vsa/metadata/supported-capacity-tiers',
                params: {
                    region: 'us-west-1',
                    ontapVersion: 'ONTAP-version-num',
                    dataEncryptionType: 'NONE',
                    licenseType: 'cot-standard-paygo',
                    instanceType: 'x4.large',
                    subscriptionId: undefined,
                    cloudProviderAccountId: 'cloudProviderAccountId'
                }
            }, 'retrieving supported capacity tiers', j.nocHttp.LOADING);
        });
    });

    describe('getPossibleTiers', () => {
        beforeEach(() => {
            jest.spyOn(j.nocHttp, 'get').mockReturnValue(j.$q.when('ApiResponse'));
        });
        it('should call right API for AWS', () => {
            jest.spyOn(TieringMetadataResource, 'initEbsDiskTypesResponse').mockReturnValue('initializedResponse');
            jest.spyOn(TieringMetadataResource, 'getSupportedCapacityTiers').mockReturnValue('capacityTiers');

            expect(TieringMetadataResource.getPossibleTiers(j.nocHttp, 'VSA', 'AWS', {
                type: 'cot-standard-paygo',
                name: 'Cloud Volumes ONTAP Standard'
            }, 'us-west-1', 'cloud-ontap-9.2-T1', 'NONE', 'x4.large'))
                .toBeResolvedWith('initializedResponse');

            expect(j.nocHttp.get).toHaveBeenCalledWith('/vsa/metadata/ebs-volume-types',
                'retrieving AWS disk types', j.nocHttp.LOADING);
            expect(TieringMetadataResource.getSupportedCapacityTiers).toHaveBeenCalledWith(j.nocHttp, '/vsa/', 'us-west-1', 'cloud-ontap-9.2-T1', 'NONE', 'cot-standard-paygo', 'x4.large', null, undefined);
            expect(TieringMetadataResource.initEbsDiskTypesResponse).toHaveBeenCalledWith('ApiResponse', 'Cloud Volumes ONTAP Standard', false, 'capacityTiers');
        });

        it('should call right API for Azure', () => {
            const pathPrefix = '/azure/vsa/';
            jest.spyOn(TieringMetadataResource, 'initAzureDiskTypesResponse').mockReturnValue('initializedResponse');

            expect(TieringMetadataResource.getPossibleTiers(j.nocHttp, 'VSA', 'Azure', {
                type: 'cot-standard-paygo',
                name: 'Cloud Volumes ONTAP Standard'
            }))
                .toBeResolvedWith('initializedResponse');

            expect(j.nocHttp.get).toHaveBeenCalledWith('/azure/vsa/metadata/storage-account-types',
                'retrieving Azure disk types', j.nocHttp.LOADING);
            expect(TieringMetadataResource.initAzureDiskTypesResponse).toHaveBeenCalledWith('ApiResponse', 'Cloud Volumes ONTAP Standard', pathPrefix);
        });

        it('should reject with error message for unknown provider', () => {
            expect(TieringMetadataResource.getPossibleTiers(j.nocHttp, 'VSA', 'newProvider', {
                type: 'cot-standard-paygo',
                name: 'Cloud Volumes ONTAP Standard'
            }))
                .toBeRejectedWith('Unknown cloud provider name newProvider');

            expect(j.nocHttp.get).not.toHaveBeenCalled();
        });
    });
});
