describe('Approval Builder Service', function () {
    'use strict';
    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });

    var nocApprovalMessageBuilder;
    beforeEach(inject(function (_nocApprovalMessageBuilder_) {
        nocApprovalMessageBuilder = _nocApprovalMessageBuilder_;
    }));

    describe('Build Title', function () {
        it('should return the approveBuyDisks message if the number of disks is greater than 0 in the error', function () {
            expect(nocApprovalMessageBuilder.buildTitle({
                provider: 'AWS',
                numOfDisks: 1,
                diskSize: {unit: 'MB', size: 15},
                diskType: 'AWS General Purpose (SSD)'
            }).$$unwrapTrustedValue()).toEqual('In order to complete your request please approve the following purchase:<ul style=\'margin-top:15px;\'><li> 1 AWS General Purpose (SSD) disk of 15 MB </li></ul>');
        });

        it('should return the approveBuyDisks message if the number of disks is greater than 1 in the error', function () {
            expect(nocApprovalMessageBuilder.buildTitle({
                provider: 'AWS',
                numOfDisks: 2,
                diskSize: {unit: 'MB', size: 15},
                diskType: 'AWS General Purpose (SSD)'
            }).$$unwrapTrustedValue()).toEqual('In order to complete your request please approve the following purchase:<ul style=\'margin-top:15px;\'><li> 2 AWS General Purpose (SSD) disks of 15 MB </li></ul>');
        });

        it('should return the noPurchaseNeeded message if the number of disks is 0 in the error', function () {
            expect(nocApprovalMessageBuilder.buildTitle({
                provider: 'AWS',
                numOfDisks: 0
            }).$$unwrapTrustedValue()).toEqual('No new AWS resources need to be purchased in order to complete this request.');
        });
    });
});