describe('nocNormalizerService', () => {
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    describe('normalizeUsersGroups() should', () => {
        const assertNormalize = (list,normalized) => {
            it(`split '${list}'`, inject((nocNormalizerService) => {
                expect(nocNormalizerService.normalizeUsersGroups(list)).toEqual(normalized);
            }));
        };

        assertNormalize('a;b', ['a', 'b']);
        assertNormalize('a;b;c', ['a', 'b', 'c']);
        assertNormalize('a', ['a']);

        //trim
        assertNormalize('a; b\t;c  ', ['a', 'b', 'c']);

        //omit empty values
        assertNormalize('a;;c;', ['a', 'c']);
        assertNormalize('a; ;  ;c', ['a', 'c']);
    });

    describe('normalizeCustomAccessControl() should', () => {
        const assertNormalize = (list,normalized) => {
            it(`split '${list}'`, inject((nocNormalizerService) => {
                expect(nocNormalizerService.normalizeCustomAccessControl(list)).toEqual(normalized);
            }));
        };

        assertNormalize('a,b', ['a', 'b']);
        assertNormalize('a,b,c', ['a', 'b', 'c']);
        assertNormalize('a', ['a']);

        //trim
        assertNormalize('a, b\t,c  ', ['a', 'b', 'c']);

        //omit empty values
        assertNormalize('a,,c,', ['a', 'c']);
        assertNormalize('a, ,  ,c', ['a', 'c']);
    });
});