describe('Add Key Manager CA Certificate Controller', function () {
    'use strict';
    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });

    beforeEach(function () {
        magnifispec.mockDialogController('AddKeyManagerCaCertificateController');
    });

    describe('saveAddKeyManager', function () {

        it('should handle form validity when not valid', function () {
            j.scope.addKeyManagerCaCertificateForm = {$valid: false};
            j.scope.saveAddKeyManagerCaCertificate();
            expect(j.nocUI.handleFormValidity).toHaveBeenCalled();
        });

        describe('when form is valid', function () {
            beforeEach(function () {
                j.scope.addKeyManagerCaCertificateForm = {$valid: true};
                j.scope.gridOptionsKeyManagers = {};
                j.scope.newKeyManagerCaCertificate = 'certificate1';
            });

            it('should work upon success', function () {
                j.$httpBackend.expectPOST(j.nocBaseUrl + '/occm/encryption/key-managers-ca-certificates', {
                    certificate: 'certificate1'
                }).respond(200, 'value1');

                j.scope.saveAddKeyManagerCaCertificate();
                j.$httpBackend.flush();

                expect(j.scope.closeDialog).toHaveBeenCalled();
            });

            it('should work upon error', function () {
                j.$httpBackend.expectPOST(j.nocBaseUrl + '/occm/encryption/key-managers-ca-certificates', {
                    certificate: 'certificate1'
                }).respond(400, j.errorResponse);

                j.scope.saveAddKeyManagerCaCertificate();
                j.$httpBackend.flush();

                expect(j.pidgeon.error).toHaveBeenCalled();
            });

            afterEach(function () {
                expect(j.pidgeon.clear).toHaveBeenCalled();
                expect(j.nocUI.block).toHaveBeenCalled();
                expect(j.nocUI.unblock).toHaveBeenCalled();
            });
        });
    });
});