describe("ShutdownVSAController", function () {
    "use strict";
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    
    beforeEach(function () {
        magnifispec.mockTabsController("setOffboxTargetController", {}, {
            selectedWorkingEnvironment: {_pathPrefix:"/vsa/",publicId: 1, ontapClusterProperties: {offboxTarget: false}}
        });
    });

    describe("click", function () {
        beforeEach(function () {
            jest.spyOn(j.scope, "setOffboxTarget").mockImplementation(() => {});
        });
        it("should do nothing if not confirm", function () {
            magnifispec.fakeConfirmNew(false);
            j.scope.click();
            expect(j.scope.setOffboxTarget).not.toHaveBeenCalled();
        });

        it("should set offbox target if confirmed", function () {
            magnifispec.fakeConfirmNew(true);
            j.scope.click();
            expect(j.scope.setOffboxTarget).toHaveBeenCalled();
        });
        afterEach(function () {
            expect(j.nocDialog.confirm).toHaveBeenCalledWith("Would you like to set this instance of Cloud Manager as this working environment's backup target?");
        });
    });

    describe("setOffboxTarget", function () {
        it("should work upon success", function () {
            j.$httpBackend.expectPUT(j.nocBaseUrl + '/vsa/working-environments/' + '1' + '/offbox').respond(200, "");

            j.scope.setOffboxTarget();
            j.$httpBackend.flush();

            expect(j.scope.selectedWorkingEnvironment.ontapClusterProperties.offboxTarget).toBeTruthy();
        });

        it("should work upon error", function () {
            j.$httpBackend.expectPUT(j.nocBaseUrl + '/vsa/working-environments/' + '1' + '/offbox').respond(400, j.errorResponse);

            j.scope.setOffboxTarget();
            j.$httpBackend.flush();

            expect(j.pidgeon.error).toHaveBeenCalled();
            expect(j.scope.selectedWorkingEnvironment.ontapClusterProperties.offboxTarget).toBeFalsy();
        });

        afterEach(function () {
            expect(j.nocUI.block).toHaveBeenCalled();
            expect(j.nocUI.unblock).toHaveBeenCalled();
        });
    });
});

