describe('Upload license file controller spec', () => {
    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    let uploadLicenseFileSpy;

    beforeEach(() => {
        magnifispec.mockTabsController('UploadLicenseFileController', {}, {
            selectedWorkingEnvironment: {_pathPrefix: '/vsa/', publicId: '1', workingEnvironmentType: 'VSA'},
            modalOk: jest.fn(),
            modalCancel: jest.fn()
        });

        uploadLicenseFileSpy = jest.spyOn(j.workingEnvironmentResource, 'uploadLicenseFile').mockReturnValue(j.$q.when());
    });

    describe('uploadLicenseFile', () => {
        const hiddenInput = {
            files: [{name: 'license.json'}],
            parent: () => {
                return [{reset: _.noop}];
            }
        };

        it('should return ok on successful upload', () => {
            j.scope.upload = jest.fn().mockReturnValue(j.$q.when());
            uploadLicenseFileSpy.mockReturnValue(j.$q.when());

            j.scope.uploadLicenseFile(hiddenInput);
            magnifispec.processPromise(); //Initiate .then()

            expect(j.scope.modalOk).toHaveBeenCalled();
        });
    });
});
