describe('VolumeInformationController', () => {
    var j;    beforeEach(() => {        j = magnifispec.setup();    });

    beforeEach(() => {
        j.$stateParams.selectedVolumeName = 'vol1';
        j.$stateParams.selectedVolumeSVM = 'svm1';

        magnifispec.mockTabsController('VolumeInformationController', {}, {
            selectedWorkingEnvironment: {
                publicId: 'wepid',
                name: 'weName',
                workingEnvironmentType: 'VSA',
                _typeLongName: 'ONTAP',
                _cloudProviderName: 'AWS',
                providerVolumeType: 'gp2'
            },
            volumes: [
                {name: 'vol0', svmName: 'svm1'},
                {name: 'vol1', svmName: 'svm1', a: {b: 'c'}},
                {name: 'vol2', svmName: 'svm1'}
            ]
        });
        magnifispec.processPromise();
    });

    describe('initialize', () => {
        it('should find selectedVolume by stateParams', () => {
            expect(j.scope.selectedVolume).toEqual({
                name: 'vol1',
                svmName: 'svm1',
                a: {b: 'c'},
                _displayDeduplicationSpaceSaved: 'None',
                _displayCompressionSpaceSaved: 'None'
            });
        });

        it('should deep copy the selectedVolume', () => {
            expect(j.scope.selectedVolume).not.toEqual(j.scope.volumes[1]);
        });

        it('should initialize storage efficiency data if exist', () => {
            j.scope.volumes[1].compressionSpaceSaved = {size: 2048, unit: 'GB'};
            j.scope.volumes[1].deduplicationSpaceSaved = {size: 3072, unit: 'GB'};

            j.scope.initialize();

            expect(j.scope.selectedVolume._displayDeduplicationSpaceSaved).toEqual('2 TB');
            expect(j.scope.selectedVolume._displayCompressionSpaceSaved).toEqual('3 TB');
        });
    });
});
