describe('Cost Annual Savings Component', () => {
    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });
    let controller;
    const mockSavingDataSave = {
        'savings': [{
            'name': 'Thin Provisioning',
            'monthlySaving': {'amount': 180, 'currency': 'USD'}
        }, {'name': 'Compression', 'monthlySaving': {'amount': 5, 'currency': 'USD'}}, {
            'name': 'Deduplication',
            'monthlySaving': {'amount': 1, 'currency': 'USD'}
        }, {'name': 'Tiering', 'monthlySaving': {'amount': 0, 'currency': 'USD'}}]
    };
    const mockSavingDataNoSave = {
        'savings': [{
            'name': 'Thin Provisioning',
            'monthlySaving': {'amount': -180, 'currency': 'USD'}
        }, {'name': 'Compression', 'monthlySaving': {'amount': 5, 'currency': 'USD'}}, {
            'name': 'Deduplication',
            'monthlySaving': {'amount': 1, 'currency': 'USD'}
        }, {'name': 'Tiering', 'monthlySaving': {'amount': 0, 'currency': 'USD'}}]
    };

    describe('Cost With Save', () => {
        beforeEach(inject(($componentController) => {
            controller = $componentController('costAnnualSavingsComponent', null, {
                savingsData: mockSavingDataSave
            });
        }));

        it('calc total savings with save', () => {
            controller.$onInit();
            expect(controller.totalSaving).toEqual(186);
            expect(controller.isOntapSaveCost).toEqual(true);
        });
    });

    describe('Cost With No Save', () => {
        beforeEach(inject(($componentController) => {
            controller = $componentController('costAnnualSavingsComponent', null, {
                savingsData: mockSavingDataNoSave
            });
        }));

        it('calc total savings with no save', () => {
            controller.$onInit();
            expect(controller.totalSaving).toEqual(-174);
            expect(controller.isOntapSaveCost).toEqual(false);
        });
    });
});
