describe.skip('costComponent', () => {
    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });

    const responseWithData = {
        costResponse: {costByTime: [{total: {amount: 12}}], hasPermissions: true},
        workingEnvironment: {ontapClusterProperties: {creationTime: moment('2018-10-19 13:00')}}
    };

    const responseWithoutData = {
        costResponse: {costByTime: [{total: {amount: 0}}], hasPermissions: true},
        workingEnvironment: {ontapClusterProperties: {creationTime: moment('2018-10-19 13:00')}}
    };
    let controller;

    describe('init', () => {
        it('should set isNewVsa to true if first month total is 0 and hours since creation is less than 30', () => {
            inject(($componentController) => {
                controller = $componentController('costComponent', null, {costAndSavingsResponse: responseWithoutData});
            });
            const now = moment('2018-10-19 19:00').toDate();
            advanceTo(now);
            controller.$onInit();
            expect(controller.isNewVsa).toEqual(true);
        });

        it('should set isNewVsa to false if first month total is not 0', () => {
            inject(($componentController) => {
                controller = $componentController('costComponent', null, {costAndSavingsResponse: responseWithData});
            });
            const now = moment('2018-10-19 19:00').toDate();
            advanceTo(now);
            controller.$onInit();
            expect(controller.isNewVsa).toEqual(false);
        });

        it('should set isNewVsa to false if hours since creation is more than 30', () => {
            inject(($componentController) => {
                controller = $componentController('costComponent', null, {costAndSavingsResponse: responseWithData});
            });
            const now = moment('2018-10-21 20:00').toDate();
            advanceTo(now);
            controller.$onInit();
            expect(controller.isNewVsa).toEqual(false);
        });

        afterEach(() => {
            jasmine.clock().uninstall();
        });
    });
});
