describe("Cost Legacy Controller", () => {
    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });

    // let workingEnvironment = {publicId: "1", name: "we1"};
    let costResponse = {
        storage: {ebsSize: {size: 1, unit: "GB"}, requestedSize: {size: 2, unit: "GB"}},
        costs: [{
            month: 1,
            year: 2013,
            storageCost: {amount: 1, unit: "USD"},
            computeCost: {amount: 1, unit: "USD"}
        }, {month: 2, year: 2014, storageCost: {amount: 2, unit: "USD"}, computeCost: {amount: 2, unit: "USD"}}]
    };
    //let stopPolling = jasmine.createSpy("stopPolling");
    let controller;

    /*beforeEach(() => {
        spyOn(j.workingEnvironmentResource, "startCostPolling").mockReturnValue(stopPolling);
        magnifispec.mockTabsController("CostLegacyController", {}, {
            selectedWorkingEnvironment: workingEnvironment,
            updateSelectedWorkingEnvironment: j.$q.when
        });
        magnifispec.processPromise();
    });*/


    beforeEach(inject(($componentController) => {
        controller = $componentController('costLegacyComponent', null, {
            costResponse: costResponse
        });
        controller.$onInit();
        magnifispec.processPromise();
    }));


    describe('check we do not save shit', () => {
        it('should mark weDontSaveShit as true if applicable', () => {
            controller.costResponse.storage.ebsSize.size = 4;

            controller.$onInit();

            expect(controller.weDontSaveShit).toEqual(true);
            expect(controller.savePercentage).toBeUndefined();
            controller.costResponse.storage.ebsSize.size = 1;
        });

        it("should handle retrieving costResponse successfully", () => {
            expect(controller.weDontSaveShit).toEqual(false);
            expect(controller.savePercentage).toEqual(50);

            expect(controller.thisMonth).toEqual({
                month: 2,
                year: 2014,
                storageCost: {amount: 2, unit: "USD"},
                computeCost: {amount: 2, unit: "USD"}
            });
        });
    });


    describe("constructing chart data", () => {
        it("should construct pie chart datum properly", () =>
            expect(controller.constructPieData(
                {storage: {ebsSize: {size: 10}, requestedSize: {size: 20}}}))
                .toEqual({
                    ebsPercent: 0.5,
                    data: [{y: 10, color: 'url(#img1)', name: "EBS Capacity"}, {
                        y: 10,
                        color: '#226db6',
                        name: "Required Capacity"
                    }]
                })
        );

        it("should construct bar chart datum properly", () =>
            expect(controller.constructBarData({
                costs: [{
                    month: 1,
                    year: 2014,
                    storageCost: {amount: 200},
                    computeCost: {amount: 300}
                }, {month: 2, year: 2014, storageCost: {amount: 400}, computeCost: {amount: 500}}]
            }))
                .toEqual({
                    categories: ["January 2014", "February 2014"],
                    storageValues: [{y: 200}, {y: 400}],
                    computeValues: [{y: 300}, {y: 500}]
                })
        );
    });
});
