describe("Tenants Controller", function () {
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });

    beforeEach(function () {
        magnifispec.mockTabsController("TenantsController");

        j.extendedTenantsUrl = j.nocBaseUrl + "/tenants?fields=workingEnvironmentsInformation";
        j.tenantsUrl = j.nocBaseUrl + "/tenants";
        j.$rootScope.checkAndSetState = jest.fn();
    });

    describe("Navigating functions", function () {
        it("should call checkAndSetState with the correct parameters when newTenant is called", function () {
            j.scope.newTenant();
            expect(j.$rootScope.checkAndSetState).toHaveBeenCalledWith("^.new");
        });

        it("should call checkAndSetState with the correct parameters when editTenant is called", function () {
            j.scope.editTenant({_pathPrefix:"/vsa/",publicId: "1"});
            expect(j.$rootScope.checkAndSetState).toHaveBeenCalledWith('^.edit', {tenantId: "1"});
        });

        it("should call checkAndSetState with the correct parameters when backToGallery is called", function () {
            j.scope.backToGallery();
            expect(j.$rootScope.checkAndSetState).toHaveBeenCalledWith('^.index', undefined);
        });
    });
});

