describe.skip('Data Fabric Layout Directive', () => {
    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });
    let body, scope, workingEnvironments;
    const template = '<div noc-data-fabric-layout></div><div class="main-footer"></div>';

    beforeEach(() => {
        body = $('body');
        body.empty();
        scope = j.$rootScope.$new();
        scope.actionsRequired = {};
        scope.actionsRequiredHighestLevel = {};
    });

    describe('building the svg with 0 we', () => {
        beforeEach(() => {
            workingEnvironments = [];
        });

        it('should build an svg', () => {
            scope.workingEnvironments = workingEnvironments;
            const div = j.$compile(template)(scope);
            body.append(div);
            scope.$digest();
            expect($('svg').length).toEqual(1);
            expect($('g.container').length).toEqual(1);
            expect($('g.links-container').length).toEqual(1);
            expect($('path.link').length).toEqual(0);
            expect($('g.node').length).toEqual(0);
        });
    });

    describe('building the svg with 1 we', () => {
        beforeEach(() => {
            workingEnvironments = [
                {
                    name: 'Joe went to the sea',
                    publicId: 'and saw a turtle',
                    status: {},
                    _stateInfo: {},
                    _workingEnvironmentLocation: 'aws',
                    _allowedOperations: {}
                }
            ];
        });

        it('should take working environments and build an svg', () => {
            scope.workingEnvironments = workingEnvironments;
            const div = j.$compile(template)(scope);
            body.append(div);
            scope.$digest();
            expect($('svg').length).toEqual(1);
            expect($('g.container').length).toEqual(1);
            expect($('g.links-container').length).toEqual(1);
            expect($('path.link').length).toEqual(0);
            expect($('g.node').length).toEqual(1);
        });
    });

    describe('building the svg with 4 we and peerings', () => {
        beforeEach(() => {
            workingEnvironments = [
                {
                    name: 'k went to sea',
                    publicId: 'm',
                    _stateInfo: {},
                    status: {},
                    _workingEnvironmentLocation: 'aws',
                    _allowedOperations: {}
                },
                {
                    name: 'j went to sea',
                    publicId: 'j',
                    peers: ['m', 'o'],
                    _stateInfo: {},
                    status: {},
                    _workingEnvironmentLocation: 'azure',
                    _allowedOperations: {}
                },
                {
                    name: 'h went to sea',
                    publicId: 'h',
                    peers: ['o', 'j'],
                    _stateInfo: {},
                    status: {},
                    _workingEnvironmentLocation: 'on_prem',
                    _allowedOperations: {}
                },
                {
                    name: 'o went to sea',
                    publicId: 'o',
                    peers: ['h', 'j'],
                    _stateInfo: {},
                    status: {},
                    _workingEnvironmentLocation: 'softLayer',
                    _allowedOperations: {}
                }
            ];
        });

        it('should take working environments and build an svg', () => {
            scope.workingEnvironments = workingEnvironments;
            const div = j.$compile(template)(scope);
            body.append(div);
            scope.$digest();
            expect($('svg').length).toEqual(1);
            expect($('g.container').length).toEqual(1);
            expect($('g.links-container').length).toEqual(1);
            expect($('path.link').length).toEqual(6);
            expect($('g.node').length).toEqual(4);
        });
    });
});
