describe("Replication status monitoring Controller", function () {
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });
    var workingEnvironment = {_pathPrefix:"/vsa/",publicId: "1", name: "we1"};
    var stopper;
    beforeEach(function () {
        stopper = jest.fn();
        jest.spyOn(j.replicationResource, 'startReplicationStatusPolling').mockReturnValue(stopper);
        magnifispec.mockTabsController("ReplicationStatusMonitoringController", {}, {
            selectedTenant : {publicId :1},
            updateSelectedWorkingEnvironment: jest.fn().mockReturnValue(j.$q.when()),
            selectedWorkingEnvironment: workingEnvironment,
            backToGallery: jest.fn()
        });

        magnifispec.processPromise();
    });

    describe("initializeController", function () {
        it("should start polling", function () {
            j.scope.initializeController(workingEnvironment);

            expect(j.replicationResource.startReplicationStatusPolling).toHaveBeenCalledWith(workingEnvironment);
        });
    });

    describe("destroy", function () {
        it("should stop polling", function () {
            j.$rootScope.$broadcast('$destroy');
            expect(stopper).toHaveBeenCalled();
        });
    });
});