describe.skip('Wizard Continue Button', () => {
    'use strict';
    let element, scope;
    var j;
    beforeEach(() => {
        j = magnifispec.setup();
    });

    beforeEach(() => {
        scope = j.$rootScope.$new();
        element = j.$compile('<ng-form name="form1"><noc-continue click="spy()"></noc-continue></ng-form>')(scope);
        scope.spy = jest.fn();
        scope.$digest();
    });

    it('should call spy on click', () => {
        element.find('button').click();
        expect(scope.spy).toHaveBeenCalled();
    });

    it('should add remove class according to form validity', () => {
        const button = element.find('button');
        const form = scope.form1;

        scope.$apply(() => {
            form.$setValidity('anyKey', true);
        });
        expect(button.hasClass('ok2go')).toEqual(true);

        scope.$apply(() => {
            form.$setValidity('anyKey', false);
        });
        expect(button.hasClass('ok2go')).toEqual(false);
    });

    describe('the continue button', () => {
        beforeEach(() => {
            element = j.$compile('<ng-form id="form1"><noc-continue click="spy()"></noc-continue></ng-form>')(scope);
            scope.$digest();
        });

        it('should button up', () => {
            expect(element.find('button').hasClass('continue-btn')).toEqual(true);
            expect(element.find('div>div').html()).toEqual('Continue');
        });
    });

    describe('the go button', () => {
        beforeEach(() => {
            element = j.$compile('<ng-form id="form1"><noc-continue class="go" click="spy()"></noc-continue></ng-form>')(scope);
            scope.$digest();
        });

        it('should button up add right class and remove label', () => {
            expect(element.find('button').hasClass('go-btn')).toEqual(true);
            expect(element.find('div').children().length).toEqual(1);
        });
    });
});
