describe("RemoveWeReviewController", function () {
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });

    describe("should load all wes on init", function () {
        beforeEach(inject(function () {
            magnifispec.mockWizardStepController("RemoveWeReviewController", {});
            j.scope.setPathToPreviousOrRoot = jest.fn();

        }));

        describe("vsa removal", function () {
            beforeEach(function () {
                j.scope.removeWELocally({_pathPrefix:"/vsa/",name: "wename", tenantId: 1, status: "MY_STATUS"});

                expect(j.nocUI.loading.mock.calls.length).toBe(1);
                expect(j.pidgeon.clear.mock.calls.length).toBe(1);
                this.pidgeonName = mostRecentCall(j.pidgeon.clear)[0];

            });

            it("removeWELocally", function () {
                j.$httpBackend.expectDELETE(/vsa\/working-environments.*localDelete=true/).respond();
                j.$httpBackend.flush();

                expect(j.scope.setPathToPreviousOrRoot.mock.calls.length).toBe(1);
                expect(j.pidgeon.success.mock.calls.length).toBe(1);
            });
        });

        describe("ha vsa removal", function () {
            it("remove-HA-VSA-WELocally", function () {
                j.scope.removeWELocally({_pathPrefix:"/aws/ha/", name: "wename", tenantId: 1, status: "MY_STATUS", isHA: true});

                j.$httpBackend.expectDELETE(/aws\/ha\/working-environments.*localDelete=true/).respond();
                j.$httpBackend.flush();

                expect(j.scope.setPathToPreviousOrRoot.mock.calls.length).toBe(1);
                expect(j.pidgeon.success.mock.calls.length).toBe(1);
            });
        });

        it("and handle error properly", function () {
            j.scope.removeWELocally({_pathPrefix:"/vsa/",name: "wename", tenantId: 1, status: "MY_STATUS"});

            j.$httpBackend.expectDELETE(/vsa\/working-environments.*localDelete=true/).respond(500);
            j.$httpBackend.flush();

            expect(j.scope.setPathToPreviousOrRoot).not.toHaveBeenCalled();
            expect(j.pidgeon.success).not.toHaveBeenCalled();
            expect(j.pidgeon.error.mock.calls.length).toBe(1);
            expect(mostRecentCall(j.pidgeon.error)[2]).toEqual("removing working environment 'wename' from Cloud Manager");
        });

        afterEach(function () {
            expect(j.nocUI.loading.mock.calls.length).toBe(1);//should not be called again
            expect(j.nocUI.unloading.mock.calls.length).toBe(1);
        });
    });
});

