describe("RemoveWeSelectWEController", function(){
    "use strict";

    var j;    beforeEach(() => {        j = magnifispec.setup();    });

    beforeEach(inject(function (nocTenantsService) {
        jest.spyOn(nocTenantsService, 'getTenantsFromServer').mockReturnValue(j.$q.when([{publicId: 1, name: "tenant1"}]));
        magnifispec.mockWizardStepController("RemoveWeSelectWEController", {});

        expect(j.nocUI.loading.mock.calls.length).toBe(1);
        expect(j.pidgeon.clear.mock.calls.length).toBe(1);
        this.pidgeonName = mostRecentCall(j.pidgeon.clear)[0];
    }));

    afterEach(function () {
        expect(j.nocUI.loading.mock.calls.length).toBe(1);//should still be 1
        expect(j.nocUI.unloading.mock.calls.length).toBe(1);
        expect(j.pidgeon.clear.mock.calls.length).toBe(1);//should still be 1
    });

    it("and add tenant names and extra info to each", function () {
        j.$httpBackend.expectGET(j.nocBaseUrl + "/working-environments?fields=status").respond({vsaWorkingEnvironments: [{name:"wename",tenantId:1, status: {status: "MY_STATUS"}, workingEnvironmentType: "VSA"}]});
        j.$httpBackend.flush();
        var we = j.scope.gridOptions.data[0];

        expect(we.name).toEqual("wename");
        expect(we._tenantName).toEqual("tenant1");
        expect(we.status.status).toEqual("my-status");

        expect(j.pidgeon.error).not.toHaveBeenCalled();

    });

    it("and do nothing if there are none", function () {
        j.$httpBackend.expectGET(j.nocBaseUrl + "/working-environments?fields=status").respond([]);
        j.$httpBackend.flush();
        expect(j.scope.gridOptions.data).toEqual([]);

        expect(j.pidgeon.error).not.toHaveBeenCalled();
    });

    it("and handle error properly", function () {
        j.$httpBackend.expectGET(j.nocBaseUrl + "/working-environments?fields=status").respond(500);
        j.$httpBackend.flush();
        expect(j.pidgeon.error.mock.calls.length).toBe(1);
        expect(mostRecentCall(j.pidgeon.error)[2]).toEqual(this.pidgeonName);
    });
});

