const fs = require('fs');
const path = require('path');

export const requireContext = (base = '.', scanSubDirectories = false, regularExpression = /\.js$/, excludedFiles) => {
    // @ts-ignore
    if (typeof require.context !== 'undefined') {
        // @ts-ignore
        return require.context(base, scanSubDirectories, regularExpression);
    }

    const files = {};

    function readDirectory(directory) {
        fs.readdirSync(directory).forEach((file) => {
            const fullPath = path.resolve(directory, file);

            if (fs.statSync(fullPath).isDirectory()) {
                if (scanSubDirectories) readDirectory(fullPath);

                return;
            }

            if (!regularExpression.test(fullPath)) {
                return;
            }

            files[fullPath] = true;
        });
    }

    readDirectory(path.resolve(__dirname, base));

    function Module(file) {
        console.log(file);
        // file.includes('error') && console.log(file);
        return require(file);
    }

    // @ts-ignore
    // Module.keys = () => Object.keys(files);
    Object.keys(files).filter(file => {
        let result = true;

        excludedFiles.forEach(excludedFilePath => {
            if (file.includes(excludedFilePath)) {
                result = false;
            }
        });

        return result;
    }).forEach(require);

    return Module;
};

export const createSpyObj = (baseName, methodNames) => {
    let obj = {};

    for (let i = 0; i < methodNames.length; i++) {
        obj[methodNames[i]] = jest.fn();
    }

    return obj;
};

export const mostRecentCall =( spy) => {
    return spy.mock.calls[spy.mock.calls.length - 1];
};